package physapps.electrodynamics;

import physbeans.inout.*;
import physbeans.math.*;
import physbeans.model.*;

/**
 * template for simulation applets<br>
 * contains an input, object and output panel<br>
 *
 */
public class ElectricDipole extends PhysBeansApplet {
  
  static public void main(String[] args) {
    startApp(new ElectricDipole(), 580, 490);
  }
  
  /** Creates new form Simulation */
  public void init() {
    setLocale();
    initComponents();
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    electrostaticPointCharges1 = new physbeans.phys.ElectrostaticPointCharges();
    cutFunction1 = new physbeans.func.CutFunction();
    cutFunction2 = new physbeans.func.CutFunction();
    imageView1 = new physbeans.views.ImageView();
    vectorFieldView1 = new physbeans.views.VectorFieldView();
    simpleFigureView1 = new physbeans.views.SimpleFigureView();
    functionView1 = new physbeans.views.FunctionView();
    functionView2 = new physbeans.views.FunctionView();
    jPanel1 = new javax.swing.JPanel();
    jPanel2 = new javax.swing.JPanel();
    objectPanel1 = new physbeans.inout.ObjectPanel();
    layeredScreen1 = new physbeans.inout.LayeredScreen();
    outputPanel1 = new physbeans.inout.OutputPanel();
    physicsPanel1 = new physbeans.inout.PhysicsPanel();
    vectorTextField1 = new physbeans.inout.VectorTextField();
    vectorTextField2 = new physbeans.inout.VectorTextField();
    physicsPanel2 = new physbeans.inout.PhysicsPanel();
    layeredScreen2 = new physbeans.inout.LayeredScreen();
    inputPanel1 = new physbeans.inout.InputPanel();
    textSlider4 = new physbeans.inout.TextSlider();
    textSlider1 = new physbeans.inout.TextSlider();
    switchBox1 = new physbeans.inout.SwitchBox();
    textSlider2 = new physbeans.inout.TextSlider();
    textSlider3 = new physbeans.inout.TextSlider();
    switchBox2 = new physbeans.inout.SwitchBox();

    electrostaticPointCharges1.setCharges(DVector.valueOf("[-1.0,1.0]"));
    electrostaticPointCharges1.setCoordinates(new Point2dVector(new double[]{-0.5,0.5}, new double[]{0.0,0.0}));
    electrostaticPointCharges1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        electrostaticPointCharges1SourceChanged1(evt);
        electrostaticPointCharges1SourceChanged2(evt);
        electrostaticPointCharges1SourceChanged3(evt);
        electrostaticPointCharges1SourceChanged(evt);
      }
    });
    electrostaticPointCharges1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        electrostaticPointCharges1ValueChanged(evt);
      }
    });

    cutFunction1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        cutFunction1ValueChanged(evt);
      }
    });

    cutFunction2.setVertical(true);
    cutFunction2.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        cutFunction2ValueChanged(evt);
      }
    });

    imageView1.setDepth(70);
    imageView1.setInfiniteScale(true);
    imageView1.setModel(electrostaticPointCharges1);
    imageView1.setScale(20.0);
    imageView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        imageView1SourceChanged(evt);
      }
    });

    vectorFieldView1.setNGridX(20);
    vectorFieldView1.setNGridY(10);
    vectorFieldView1.setDepth(60);
    vectorFieldView1.setMaxArrowLength(0.3);
    vectorFieldView1.setModel(electrostaticPointCharges1);
    vectorFieldView1.setVectorScale(0.005);
    vectorFieldView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        vectorFieldView1SourceChanged(evt);
      }
    });

    simpleFigureView1.setFigureType(1);
    simpleFigureView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        simpleFigureView1SourceChanged(evt);
      }
    });

    functionView1.setLineColor(new java.awt.Color(0, 94, 191));
    functionView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        functionView1SourceChanged(evt);
      }
    });

    functionView2.setDepth(40);
    functionView2.setLineColor(new java.awt.Color(0, 191, 97));
    functionView2.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        functionView2SourceChanged(evt);
      }
    });

    jPanel1.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED)));
    jPanel1.setFont(standardFont);
    jPanel1.setLayout(new java.awt.BorderLayout());

    jPanel2.setFont(standardFont);
    jPanel2.setLayout(new javax.swing.BoxLayout(jPanel2, javax.swing.BoxLayout.Y_AXIS));

    objectPanel1.setBordered(true);

    layeredScreen1.setCrossCursor(true);
    layeredScreen1.setEqualScales(true);
    layeredScreen1.setViewActive(new boolean[]{true,true,false});
    layeredScreen1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        layeredScreen1ValueChanged(evt);
      }
    });
    objectPanel1.add(layeredScreen1, java.awt.BorderLayout.CENTER);

    jPanel2.add(objectPanel1);

    outputPanel1.setBordered(true);
    outputPanel1.setLayout(new java.awt.BorderLayout());

    physicsPanel1.setBordered(true);
    physicsPanel1.setLayout(new javax.swing.BoxLayout(physicsPanel1, javax.swing.BoxLayout.Y_AXIS));
    physicsPanel1.add(vectorTextField1);

    vectorTextField2.setDescription(new String[] {"Ex =", "Ey ="});
    vectorTextField2.setUnit(new String[] {"V/m", "V/m"});
    physicsPanel1.add(vectorTextField2);

    outputPanel1.add(physicsPanel1, java.awt.BorderLayout.WEST);

    physicsPanel2.setBordered(true);
    physicsPanel2.setLayout(new javax.swing.BoxLayout(physicsPanel2, javax.swing.BoxLayout.LINE_AXIS));

    layeredScreen2.setBackground(new java.awt.Color(255, 255, 255));
    layeredScreen2.setMaxY(50.0);
    layeredScreen2.setMinY(0.0);
    layeredScreen2.setOpaque(true);
    layeredScreen2.setViewActive(new boolean[]{true,false});
    physicsPanel2.add(layeredScreen2);

    outputPanel1.add(physicsPanel2, java.awt.BorderLayout.CENTER);

    jPanel2.add(outputPanel1);

    jPanel1.add(jPanel2, java.awt.BorderLayout.CENTER);

    inputPanel1.setPreferredSize(new java.awt.Dimension(216, 402));
    inputPanel1.setLayout(new javax.swing.BoxLayout(inputPanel1, javax.swing.BoxLayout.Y_AXIS));

    textSlider4.setColumns(7);
    textSlider4.setDescription("q =");
    textSlider4.setLogarithmic(true);
    textSlider4.setModel(new BoundedRealModel(1.0E-11,1.0E-10,1.0E-9));
    textSlider4.setUnit("C");
    textSlider4.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider4PropertyChange(evt);
      }
    });
    inputPanel1.add(textSlider4);

    textSlider1.setDescription("d =");
    textSlider1.setModel(new BoundedRealModel(0.0,1.0,4.0));
    textSlider1.setUnit("m");
    textSlider1.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider1PropertyChange(evt);
      }
    });
    inputPanel1.add(textSlider1);

    switchBox1.setBoxLabel(new String[] {
      java.util.ResourceBundle.getBundle("physapps.electrodynamics.ElectricDipole", currentLocale).getString("s1"),
      java.util.ResourceBundle.getBundle("physapps.electrodynamics.ElectricDipole", currentLocale).getString("s2"),
      java.util.ResourceBundle.getBundle("physapps.electrodynamics.ElectricDipole", currentLocale).getString("s3")
    });
    switchBox1.setSelected(new boolean[]{true,true,false});
    java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("physapps.electrodynamics.ElectricDipole", currentLocale); // NOI18N
    switchBox1.setTitle(bundle.getString("s4")); // NOI18N
    switchBox1.addSwitchListener(new physbeans.event.SwitchListener() {
      public void valueChanged(physbeans.event.SwitchEvent evt) {
        switchBox1ValueChanged(evt);
      }
    });
    inputPanel1.add(switchBox1);

    textSlider2.setDescription("x =");
    textSlider2.setModel(new BoundedRealModel(-1.0,0.0,1.0));
    textSlider2.setUnit("m");
    textSlider2.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider2PropertyChange1(evt);
        textSlider2PropertyChange(evt);
      }
    });
    inputPanel1.add(textSlider2);

    textSlider3.setDescription("y =");
    textSlider3.setModel(new BoundedRealModel(-1.0,0.14,1.0));
    textSlider3.setUnit("m");
    textSlider3.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider3PropertyChange(evt);
        textSlider3PropertyChange1(evt);
      }
    });
    inputPanel1.add(textSlider3);

    switchBox2.setBoxLabel(new String[] {
      java.util.ResourceBundle.getBundle("physapps.electrodynamics.ElectricDipole", currentLocale).getString("s5"),
      java.util.ResourceBundle.getBundle("physapps.electrodynamics.ElectricDipole", currentLocale).getString("s6")
    });
    switchBox2.setSelected(new boolean[]{true,false});
    switchBox2.setTitle(bundle.getString("s7")); // NOI18N
    switchBox2.addSwitchListener(new physbeans.event.SwitchListener() {
      public void valueChanged(physbeans.event.SwitchEvent evt) {
        switchBox2ValueChanged(evt);
      }
    });
    inputPanel1.add(switchBox2);

    jPanel1.add(inputPanel1, java.awt.BorderLayout.EAST);

    getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
  }// </editor-fold>//GEN-END:initComponents
  
  private void electrostaticPointCharges1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_electrostaticPointCharges1ValueChanged
    vectorTextField2.setValue(electrostaticPointCharges1.getLastVectorValue());
  }//GEN-LAST:event_electrostaticPointCharges1ValueChanged
  
  private void simpleFigureView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_simpleFigureView1SourceChanged
    layeredScreen1.addView(simpleFigureView1);
  }//GEN-LAST:event_simpleFigureView1SourceChanged
  
  private void vectorFieldView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_vectorFieldView1SourceChanged
    layeredScreen1.addView(vectorFieldView1);
  }//GEN-LAST:event_vectorFieldView1SourceChanged
  
  private void imageView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_imageView1SourceChanged
    layeredScreen1.addView(imageView1);
  }//GEN-LAST:event_imageView1SourceChanged
  
  private void functionView2SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_functionView2SourceChanged
    layeredScreen2.addView(functionView2);
  }//GEN-LAST:event_functionView2SourceChanged
  
  private void functionView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_functionView1SourceChanged
    layeredScreen2.addView(functionView1);
  }//GEN-LAST:event_functionView1SourceChanged
  
    private void layeredScreen1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_layeredScreen1ValueChanged
      vectorTextField1.setValue(layeredScreen1.getClickedPosition());
      electrostaticPointCharges1.sendVectorValue(layeredScreen1.getClickedPosition());
    }//GEN-LAST:event_layeredScreen1ValueChanged
    
  private void cutFunction1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_cutFunction1ValueChanged
    functionView1.setModel(cutFunction1.getXVector(), cutFunction1.getYVector());
  }//GEN-LAST:event_cutFunction1ValueChanged
  
  private void cutFunction2ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_cutFunction2ValueChanged
    functionView2.setModel(cutFunction2.getXVector(), cutFunction2.getYVector());
  }//GEN-LAST:event_cutFunction2ValueChanged
  
  private void electrostaticPointCharges1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_electrostaticPointCharges1SourceChanged
    imageView1.update();
  }//GEN-LAST:event_electrostaticPointCharges1SourceChanged
  
  private void electrostaticPointCharges1SourceChanged3(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_electrostaticPointCharges1SourceChanged3
    cutFunction2.setScalarField(electrostaticPointCharges1);
  }//GEN-LAST:event_electrostaticPointCharges1SourceChanged3
  
  private void electrostaticPointCharges1SourceChanged2(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_electrostaticPointCharges1SourceChanged2
    cutFunction1.setScalarField(electrostaticPointCharges1);
  }//GEN-LAST:event_electrostaticPointCharges1SourceChanged2
  
  private void electrostaticPointCharges1SourceChanged1(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_electrostaticPointCharges1SourceChanged1
    vectorFieldView1.update();
  }//GEN-LAST:event_electrostaticPointCharges1SourceChanged1
  
  private void textSlider2PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider2PropertyChange
    // hand code
    double val = textSlider2.getValue();
    simpleFigureView1.setP1(new DVector(val, -1.0));
    simpleFigureView1.setP2(new DVector(val, 1.0));
  }//GEN-LAST:event_textSlider2PropertyChange
  
  private void textSlider2PropertyChange1(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider2PropertyChange1
    cutFunction2.setY(textSlider2.getValue());
  }//GEN-LAST:event_textSlider2PropertyChange1
  
  private void switchBox2ValueChanged(physbeans.event.SwitchEvent evt) {//GEN-FIRST:event_switchBox2ValueChanged
    layeredScreen2.setViewActive(switchBox2.getSelected());
  }//GEN-LAST:event_switchBox2ValueChanged
  
  private void switchBox1ValueChanged(physbeans.event.SwitchEvent evt) {//GEN-FIRST:event_switchBox1ValueChanged
    layeredScreen1.setViewActive(switchBox1.getSelected());
  }//GEN-LAST:event_switchBox1ValueChanged
  
  private void textSlider3PropertyChange1(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider3PropertyChange1
    // hand coded
    double val = textSlider3.getValue();
    simpleFigureView1.setP3(new DVector(-1.0, val));
    simpleFigureView1.setP4(new DVector(1.0, val));
  }//GEN-LAST:event_textSlider3PropertyChange1
  
  private void textSlider3PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider3PropertyChange
    cutFunction1.setY(textSlider3.getValue());
  }//GEN-LAST:event_textSlider3PropertyChange
  
  private void textSlider1PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider1PropertyChange
    electrostaticPointCharges1.setDistanceScale(textSlider1.getValue());
  }//GEN-LAST:event_textSlider1PropertyChange
  
  private void textSlider4PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider4PropertyChange
    electrostaticPointCharges1.setChargeScale(textSlider4.getValue());
  }//GEN-LAST:event_textSlider4PropertyChange
  
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  protected physbeans.func.CutFunction cutFunction1;
  protected physbeans.func.CutFunction cutFunction2;
  protected physbeans.phys.ElectrostaticPointCharges electrostaticPointCharges1;
  protected physbeans.views.FunctionView functionView1;
  protected physbeans.views.FunctionView functionView2;
  protected physbeans.views.ImageView imageView1;
  protected physbeans.inout.InputPanel inputPanel1;
  protected javax.swing.JPanel jPanel1;
  protected javax.swing.JPanel jPanel2;
  protected physbeans.inout.LayeredScreen layeredScreen1;
  protected physbeans.inout.LayeredScreen layeredScreen2;
  protected physbeans.inout.ObjectPanel objectPanel1;
  protected physbeans.inout.OutputPanel outputPanel1;
  protected physbeans.inout.PhysicsPanel physicsPanel1;
  protected physbeans.inout.PhysicsPanel physicsPanel2;
  protected physbeans.views.SimpleFigureView simpleFigureView1;
  protected physbeans.inout.SwitchBox switchBox1;
  protected physbeans.inout.SwitchBox switchBox2;
  protected physbeans.inout.TextSlider textSlider1;
  protected physbeans.inout.TextSlider textSlider2;
  protected physbeans.inout.TextSlider textSlider3;
  protected physbeans.inout.TextSlider textSlider4;
  protected physbeans.views.VectorFieldView vectorFieldView1;
  protected physbeans.inout.VectorTextField vectorTextField1;
  protected physbeans.inout.VectorTextField vectorTextField2;
  // End of variables declaration//GEN-END:variables
  
}
