package physapps.linearoscillations;

import physbeans.inout.*;
import physbeans.math.*;
import physbeans.model.*;

/**
 * template for simulation applets<br>
 * contains an input, object and output panel<br>
 *
 */
public class AddTwoCosEqual extends PhysBeansApplet {
  
  static public void main(String[] args) {
    startApp(new AddTwoCosEqual(), 540, 440);
  }
  
  /** Creates new form Simulation */
  public void init() {
    setLocale();
    initComponents();
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
// <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
  private void initComponents() {
    harmonicVectorFunction1 = new physbeans.func.HarmonicFunction();
    harmonicVectorFunction2 = new physbeans.func.HarmonicFunction();
    arithmeticFunction1 = new physbeans.func.ArithmeticFunction();
    multiplexer1 = new physbeans.func.Multiplexer();
    parsedFunction1 = new physbeans.func.ParsedFunction();
    jPanel1 = new javax.swing.JPanel();
    jPanel2 = new javax.swing.JPanel();
    objectPanel1 = new physbeans.inout.ObjectPanel();
    oscilloscope1 = new physbeans.inout.Oscilloscope();
    physicsPanel1 = new physbeans.inout.PhysicsPanel();
    numericTextField1 = new physbeans.inout.NumericTextField();
    numericTextField2 = new physbeans.inout.NumericTextField();
    inputPanel1 = new physbeans.inout.InputPanel();
    timer1 = new physbeans.inout.Timer();
    textSlider1 = new physbeans.inout.TextSlider();
    textSlider2 = new physbeans.inout.TextSlider();
    textSlider3 = new physbeans.inout.TextSlider();
    textSlider4 = new physbeans.inout.TextSlider();
    switchBox1 = new physbeans.inout.SwitchBox();
    
    harmonicVectorFunction1.setOmega(0.4775);
    harmonicVectorFunction1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        harmonicVectorFunction1ValueChanged(evt);
      }
    });
    
    harmonicVectorFunction2.setOmega(0.4775);
    harmonicVectorFunction2.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        harmonicVectorFunction2ValueChanged(evt);
      }
    });
    
    arithmeticFunction1.setFirstArg(0.5);
    arithmeticFunction1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        arithmeticFunction1ValueChanged(evt);
      }
    });
    
    multiplexer1.setInputLength(3);
    multiplexer1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        multiplexer1ValueChanged(evt);
      }
    });
    
    parsedFunction1.setFunction(new String[] {"sqrt(a1*a1 + a2*a2 + 2*a1*a2*cos(phi1 - phi2))", "atan2(a1*sin(phi1) + a2*sin(phi2),  a1*cos(phi1) + a2*cos(phi2))"});
    parsedFunction1.setVariableName(new String[] {"a1", "phi1", "a2", "phi2"});
    parsedFunction1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        parsedFunction1ValueChanged(evt);
      }
    });
    
    
    jPanel1.setLayout(new java.awt.BorderLayout());
    
    jPanel1.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED)));
    jPanel1.setFont(standardFont);
    jPanel2.setLayout(new java.awt.BorderLayout());
    
    jPanel2.setFont(standardFont);
    oscilloscope1.setNLines(3);
    oscilloscope1.setLineActive(new boolean[]{true,true,true});
    oscilloscope1.setMaxY(2.2);
    oscilloscope1.setMinY(-2.2);
    oscilloscope1.setPositionLabel(java.util.ResourceBundle.getBundle("physapps.linearoscillations.AddTwoCosEqual", currentLocale).getString("osciPosition"));
    oscilloscope1.setScaleLabel(java.util.ResourceBundle.getBundle("physapps.linearoscillations.AddTwoCosEqual", currentLocale).getString("osciScale"));
    objectPanel1.add(oscilloscope1, java.awt.BorderLayout.CENTER);
    
    jPanel2.add(objectPanel1, java.awt.BorderLayout.CENTER);
    
    physicsPanel1.setLayout(new javax.swing.BoxLayout(physicsPanel1, javax.swing.BoxLayout.X_AXIS));
    
    physicsPanel1.setBackground(new java.awt.Color(150, 200, 255));
    physicsPanel1.setBorder(javax.swing.BorderFactory.createEtchedBorder());
    physicsPanel1.setFont(standardFont);
    physicsPanel1.setOpaque(true);
    numericTextField1.setBordered(true);
    numericTextField1.setColumns(5);
    numericTextField1.setDescription("A =");
    numericTextField1.setEditable(false);
    numericTextField1.setUnit("m");
    physicsPanel1.add(numericTextField1);
    
    numericTextField2.setBordered(true);
    numericTextField2.setColumns(5);
    numericTextField2.setDescription("\u03c6 =");
    numericTextField2.setEditable(false);
    numericTextField2.setUnit("* \u03c0");
    physicsPanel1.add(numericTextField2);
    
    jPanel2.add(physicsPanel1, java.awt.BorderLayout.SOUTH);
    
    jPanel1.add(jPanel2, java.awt.BorderLayout.CENTER);
    
    inputPanel1.setLayout(new javax.swing.BoxLayout(inputPanel1, javax.swing.BoxLayout.Y_AXIS));
    
    timer1.setDelay(15L);
    timer1.setExplanation(java.util.ResourceBundle.getBundle("physapps.linearoscillations.AddTwoCosEqual", currentLocale).getString("timerLabel"));
    timer1.addTimerListener(new physbeans.event.TimerListener() {
      public void nextStep(physbeans.event.NextStepEvent evt) {
        timer1NextStep(evt);
      }
      public void restart(physbeans.event.RestartEvent evt) {
        timer1Restart(evt);
      }
    });
    
    inputPanel1.add(timer1);
    
    textSlider1.setDescription("A1 =");
    textSlider1.setModel(new BoundedRealModel(0.0,0.5,1.0));
    textSlider1.setUnit("m");
    textSlider1.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider1PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider1);
    
    textSlider2.setDescription("\u03c61 =");
    textSlider2.setModel(new BoundedRealModel(-1.0,0.0,1.0));
    textSlider2.setUnit("* \u03c0");
    textSlider2.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider2PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider2);
    
    textSlider3.setDescription("A2 =");
    textSlider3.setModel(new BoundedRealModel(0.0,0.5,1.0));
    textSlider3.setUnit("m");
    textSlider3.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider3PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider3);
    
    textSlider4.setDescription("\u03c62 =");
    textSlider4.setModel(new BoundedRealModel(-1.0,0.5,1.0));
    textSlider4.setUnit("* \u03c0");
    textSlider4.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider4PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider4);
    
    switchBox1.setBoxLabel(  new String[] {
      java.util.ResourceBundle.getBundle("physapps.linearoscillations.AddTwoCosEqual", currentLocale).getString("s1"),
      java.util.ResourceBundle.getBundle("physapps.linearoscillations.AddTwoCosEqual", currentLocale).getString("s2"),
      java.util.ResourceBundle.getBundle("physapps.linearoscillations.AddTwoCosEqual", currentLocale).getString("s3")
    }
    );
    switchBox1.setSelected(new boolean[]{true,true,true});
    switchBox1.setTitle(java.util.ResourceBundle.getBundle("physapps.linearoscillations.AddTwoCosEqual", currentLocale).getString("s4"));
    switchBox1.addSwitchListener(new physbeans.event.SwitchListener() {
      public void valueChanged(physbeans.event.SwitchEvent evt) {
        switchBox1ValueChanged(evt);
      }
    });
    
    inputPanel1.add(switchBox1);
    
    jPanel1.add(inputPanel1, java.awt.BorderLayout.EAST);
    
    getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
    
  }// </editor-fold>//GEN-END:initComponents
  
  private void parsedFunction1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_parsedFunction1ValueChanged
    DVector v = parsedFunction1.getOutputVector();
    numericTextField1.setValue(v.get(0));
    numericTextField2.setValue(v.get(1)/Math.PI);
  }//GEN-LAST:event_parsedFunction1ValueChanged
    
  private void harmonicVectorFunction1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_harmonicVectorFunction1ValueChanged
    double val = harmonicVectorFunction1.getOutputValue();
    arithmeticFunction1.setFirstArg(val);
    multiplexer1.setInputValues(0, val);
  }//GEN-LAST:event_harmonicVectorFunction1ValueChanged
  
  private void harmonicVectorFunction2ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_harmonicVectorFunction2ValueChanged
    double val = harmonicVectorFunction2.getOutputValue();
    arithmeticFunction1.setSecondArg(val);
    multiplexer1.setInputValues(1, val);
  }//GEN-LAST:event_harmonicVectorFunction2ValueChanged
  
  private void switchBox1ValueChanged(physbeans.event.SwitchEvent evt) {//GEN-FIRST:event_switchBox1ValueChanged
    oscilloscope1.setLineActive(switchBox1.getSelected());
  }//GEN-LAST:event_switchBox1ValueChanged
  
  private void multiplexer1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_multiplexer1ValueChanged
    oscilloscope1.setInputVector(multiplexer1.getOutputVector());
  }//GEN-LAST:event_multiplexer1ValueChanged
  
  private void arithmeticFunction1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_arithmeticFunction1ValueChanged
    multiplexer1.setInputValues(2, arithmeticFunction1.getResult());
  }//GEN-LAST:event_arithmeticFunction1ValueChanged
  
  private void textSlider4PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider4PropertyChange
    double val = Math.PI*textSlider4.getValue();
    parsedFunction1.setInputValues(3, val);
    harmonicVectorFunction2.setAlpha(val);
  }//GEN-LAST:event_textSlider4PropertyChange
  
  private void textSlider3PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider3PropertyChange
    parsedFunction1.setInputValues(2, textSlider3.getValue());
    harmonicVectorFunction2.setAmplitude(textSlider3.getValue());
  }//GEN-LAST:event_textSlider3PropertyChange
  
  private void textSlider2PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider2PropertyChange
    double val = Math.PI*textSlider2.getValue();
    parsedFunction1.setInputValues(1, val);
    harmonicVectorFunction1.setAlpha(val);
  }//GEN-LAST:event_textSlider2PropertyChange
  
  private void textSlider1PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider1PropertyChange
    parsedFunction1.singleInputValue(0, textSlider1.getValue());
    harmonicVectorFunction1.setAmplitude(textSlider1.getValue());
  }//GEN-LAST:event_textSlider1PropertyChange
  
  private void timer1Restart(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart
    oscilloscope1.restart();
  }//GEN-LAST:event_timer1Restart
  
  private void timer1NextStep(physbeans.event.NextStepEvent evt) {//GEN-FIRST:event_timer1NextStep
    harmonicVectorFunction1.setInputValue(timer1.getTime());
    harmonicVectorFunction2.setInputValue(timer1.getTime());
  }//GEN-LAST:event_timer1NextStep
  
// Variables declaration - do not modify//GEN-BEGIN:variables
  protected physbeans.func.ArithmeticFunction arithmeticFunction1;
  protected physbeans.func.HarmonicFunction harmonicVectorFunction1;
  protected physbeans.func.HarmonicFunction harmonicVectorFunction2;
  protected physbeans.inout.InputPanel inputPanel1;
  protected javax.swing.JPanel jPanel1;
  protected javax.swing.JPanel jPanel2;
  protected physbeans.func.Multiplexer multiplexer1;
  protected physbeans.inout.NumericTextField numericTextField1;
  protected physbeans.inout.NumericTextField numericTextField2;
  protected physbeans.inout.ObjectPanel objectPanel1;
  protected physbeans.inout.Oscilloscope oscilloscope1;
  protected physbeans.inout.PhysicsPanel outputPanel;
  protected physbeans.inout.PhysicsPanel outputPanel2;
  protected physbeans.func.ParsedFunction parsedFunction1;
  protected physbeans.inout.PhysicsPanel physicsPanel1;
  protected physbeans.inout.SwitchBox switchBox1;
  protected physbeans.inout.TextSlider textSlider1;
  protected physbeans.inout.TextSlider textSlider2;
  protected physbeans.inout.TextSlider textSlider3;
  protected physbeans.inout.TextSlider textSlider4;
  protected physbeans.inout.Timer timer1;
// End of variables declaration//GEN-END:variables
  
}
