package physapps.linearoscillations;

import javax.swing.*;
import java.awt.*;
import physbeans.inout.*;
import physbeans.math.*;
import physbeans.model.*;

/**
 * template for simulation applets<br>
 * contains an input, object and output panel<br>
 *
 */
public class CoupledOscillator extends PhysBeansApplet {
  
  static public void main(String[] args) {
    startApp(new CoupledOscillator(), 650, 500);
  }
  
  /** Creates new form Simulation */
  public void init() {
    setLocale();
    initComponents();
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
// <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
  private void initComponents() {
    twoSprings1 = new physbeans.phys.TwoSprings();
    selector1 = new physbeans.func.Selector();
    twoMassSpringView1 = new physbeans.views.TwoMassSpringView();
    jPanel1 = new javax.swing.JPanel();
    jPanel2 = new javax.swing.JPanel();
    objectPanel1 = new physbeans.inout.ObjectPanel();
    layeredScreen1 = new physbeans.inout.LayeredScreen();
    outputPanel1 = new physbeans.inout.OutputPanel();
    oscilloscope1 = new physbeans.inout.Oscilloscope();
    inputPanel1 = new physbeans.inout.InputPanel();
    timer1 = new physbeans.inout.Timer();
    textSlider1 = new physbeans.inout.TextSlider();
    textSlider2 = new physbeans.inout.TextSlider();
    textSlider3 = new physbeans.inout.TextSlider();
    textSlider4 = new physbeans.inout.TextSlider();
    switchBox1 = new physbeans.inout.SwitchBox();
    
    twoSprings1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        twoSprings1ValueChanged(evt);
      }
    });
    
    selector1.setIndex(new int[]{0,1});
    selector1.setInputLength(4);
    selector1.setOutputLength(2);
    selector1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        selector1ValueChanged(evt);
      }
    });
    
    twoMassSpringView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        twoMassSpringView1SourceChanged(evt);
      }
    });
    
    
    jPanel1.setLayout(new java.awt.BorderLayout());
    
    jPanel1.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED)));
    jPanel1.setFont(standardFont);
    jPanel2.setLayout(new javax.swing.BoxLayout(jPanel2, javax.swing.BoxLayout.Y_AXIS));
    
    jPanel2.setFont(standardFont);
    layeredScreen1.setBackground(java.awt.Color.white);
    layeredScreen1.setBordered(true);
    layeredScreen1.setEqualScales(true);
    layeredScreen1.setMaxX(4.2);
    layeredScreen1.setMinX(-4.2);
    layeredScreen1.setOpaque(true);
    objectPanel1.add(layeredScreen1, java.awt.BorderLayout.CENTER);
    
    jPanel2.add(objectPanel1);
    
    oscilloscope1.setMaxY(3.2);
    oscilloscope1.setMinY(-3.2);
    oscilloscope1.setPositionLabel(java.util.ResourceBundle.getBundle("physapps.linearoscillations.CoupledOscillator", currentLocale).getString("osciPosition"));
    oscilloscope1.setScaleLabel(java.util.ResourceBundle.getBundle("physapps.linearoscillations.CoupledOscillator", currentLocale).getString("osciScale"));
    outputPanel1.add(oscilloscope1);
    
    jPanel2.add(outputPanel1);
    
    jPanel1.add(jPanel2, java.awt.BorderLayout.CENTER);
    
    inputPanel1.setLayout(new javax.swing.BoxLayout(inputPanel1, javax.swing.BoxLayout.Y_AXIS));
    
    inputPanel1.setAlignmentX(0.5F);
    timer1.setExplanation(java.util.ResourceBundle.getBundle("physapps.linearoscillations.CoupledOscillator", currentLocale).getString("timerLabel"));
    timer1.addTimerListener(new physbeans.event.TimerListener() {
      public void nextStep(physbeans.event.NextStepEvent evt) {
        timer1NextStep(evt);
      }
      public void restart(physbeans.event.RestartEvent evt) {
        timer1Restart(evt);
      }
    });
    
    inputPanel1.add(timer1);
    
    textSlider1.setDescription("x1(0) =");
    textSlider1.setModel(new BoundedRealModel(-2.0,-1.3,2.0));
    textSlider1.setUnit("m");
    textSlider1.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider1PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider1);
    
    textSlider2.setDescription("x2(0) =");
    textSlider2.setModel(new BoundedRealModel(-2.0,0.0,2.0));
    textSlider2.setUnit("m");
    textSlider2.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider2PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider2);
    
    textSlider3.setDescription("c1/m =");
    textSlider3.setLogarithmic(true);
    textSlider3.setModel(new BoundedRealModel(0.1,4.0,10.0));
    textSlider3.setUnit("1/s\u00b2");
    textSlider3.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider3PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider3);
    
    textSlider4.setDescription("c2/m =");
    textSlider4.setLogarithmic(true);
    textSlider4.setModel(new BoundedRealModel(0.1,0.6,10.0));
    textSlider4.setUnit("1/s\u00b2");
    textSlider4.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider4PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider4);
    
    switchBox1.setBoxLabel(new String[] {
      java.util.ResourceBundle.getBundle("physapps.linearoscillations.CoupledOscillator", currentLocale).getString("s1"),
      java.util.ResourceBundle.getBundle("physapps.linearoscillations.CoupledOscillator", currentLocale).getString("s2")
    });
    switchBox1.setSelected(new boolean[]{true,false});
    switchBox1.setTitle(java.util.ResourceBundle.getBundle("physapps.linearoscillations.CoupledOscillator", currentLocale).getString("s3"));
    switchBox1.addSwitchListener(new physbeans.event.SwitchListener() {
      public void valueChanged(physbeans.event.SwitchEvent evt) {
        switchBox1ValueChanged(evt);
      }
    });
    
    inputPanel1.add(switchBox1);
    
    jPanel1.add(inputPanel1, java.awt.BorderLayout.EAST);
    
    getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
    
  }// </editor-fold>//GEN-END:initComponents
  
  private void twoMassSpringView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_twoMassSpringView1SourceChanged
    layeredScreen1.addView(twoMassSpringView1);
  }//GEN-LAST:event_twoMassSpringView1SourceChanged
  
  private void twoSprings1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_twoSprings1ValueChanged
    selector1.setInputVector(twoSprings1.getOutputVector());
  }//GEN-LAST:event_twoSprings1ValueChanged
  
  private void selector1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_selector1ValueChanged
    oscilloscope1.setInputVector(selector1.getOutputVector());
    twoMassSpringView1.setModel(selector1.getOutputVector());
  }//GEN-LAST:event_selector1ValueChanged

  private void switchBox1ValueChanged(physbeans.event.SwitchEvent evt) {//GEN-FIRST:event_switchBox1ValueChanged
    oscilloscope1.setLineActive(switchBox1.getSelected());
  }//GEN-LAST:event_switchBox1ValueChanged
  
  private void textSlider4PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider4PropertyChange
    double c1 = textSlider3.getValue();
    double c2 = textSlider4.getValue();
    twoSprings1.setC11(c1 + c2);
    twoSprings1.setC12(-c2);
    twoSprings1.setC22(c1 + c2);
  }//GEN-LAST:event_textSlider4PropertyChange
  
  private void textSlider3PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider3PropertyChange
    double c1 = textSlider3.getValue();
    double c2 = textSlider4.getValue();
    twoSprings1.setC11(c1 + c2);
    twoSprings1.setC22(c1 + c2);
  }//GEN-LAST:event_textSlider3PropertyChange
  
  private void textSlider2PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider2PropertyChange
    double val = textSlider2.getValue();
    twoSprings1.setInitialValue(1, val);
    twoMassSpringView1.setInitialValue(1, val);
  }//GEN-LAST:event_textSlider2PropertyChange
  
  private void timer1NextStep(physbeans.event.NextStepEvent evt) {//GEN-FIRST:event_timer1NextStep
    twoSprings1.setTime(timer1.getTime());
  }//GEN-LAST:event_timer1NextStep
  
  private void textSlider1PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider1PropertyChange
    double val = textSlider1.getValue();
    twoSprings1.setInitialValue(0, val);
    twoMassSpringView1.setInitialValue(0, val);
  }//GEN-LAST:event_textSlider1PropertyChange
  
  private void timer1Restart(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart
    oscilloscope1.restart();
    twoSprings1.restart();
    twoMassSpringView1.restart();
  }//GEN-LAST:event_timer1Restart
  
  
// Variables declaration - do not modify//GEN-BEGIN:variables
  protected physbeans.inout.InputPanel inputPanel1;
  protected javax.swing.JPanel jPanel1;
  protected javax.swing.JPanel jPanel2;
  protected physbeans.inout.LayeredScreen layeredScreen1;
  protected physbeans.inout.ObjectPanel objectPanel1;
  protected physbeans.inout.Oscilloscope oscilloscope1;
  protected physbeans.inout.OutputPanel outputPanel1;
  protected physbeans.func.Selector selector1;
  protected physbeans.inout.SwitchBox switchBox1;
  protected physbeans.inout.TextSlider textSlider1;
  protected physbeans.inout.TextSlider textSlider2;
  protected physbeans.inout.TextSlider textSlider3;
  protected physbeans.inout.TextSlider textSlider4;
  protected physbeans.inout.Timer timer1;
  protected physbeans.views.TwoMassSpringView twoMassSpringView1;
  protected physbeans.phys.TwoSprings twoSprings1;
// End of variables declaration//GEN-END:variables
  
}
