package physapps.mathematics;

import javax.swing.*;
import java.awt.*;
import physbeans.inout.*;
import physbeans.math.*;
import physbeans.model.*;

/**
 * template for simulation applets<br>
 * contains an input, object and output panel<br>
 *
 */
public class PolyFit extends PhysBeansApplet {
  
  static public void main(String[] args) {
    startApp(new PolyFit(), 650, 370);
  }
  
  /** Creates new form Simulation */
  public void init() {
    setLocale();
    initComponents();
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    strideVector1 = new physbeans.func.StrideVector();
    polynomialFitFunction1 = new physbeans.func.PolynomialFitFunction();
    polynomialFunction1 = new physbeans.func.PolynomialFunction();
    pointView1 = new physbeans.views.PointView();
    functionView1 = new physbeans.views.FunctionView();
    jPanel1 = new javax.swing.JPanel();
    jPanel2 = new javax.swing.JPanel();
    objectPanel1 = new physbeans.inout.ObjectPanel();
    layeredScreen1 = new physbeans.inout.LayeredScreen();
    outputPanel1 = new physbeans.inout.OutputPanel();
    vectorTextField1 = new physbeans.inout.VectorTextField();
    message1 = new physbeans.inout.Message();
    inputPanel1 = new physbeans.inout.InputPanel();
    pointEditor1 = new physbeans.inout.PointEditor();
    textSlider1 = new physbeans.inout.TextSlider();
    textSlider2 = new physbeans.inout.TextSlider();
    integerTextSlider1 = new physbeans.inout.IntegerTextSlider();

    strideVector1.setMinVal(-10.0);
    strideVector1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        strideVector1ValueChanged(evt);
      }
    });

    polynomialFitFunction1.setCombineMode(true);
    polynomialFitFunction1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        polynomialFitFunction1ValueChanged(evt);
      }
    });

    polynomialFunction1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        polynomialFunction1ValueChanged(evt);
      }
    });

    pointView1.setDepth(60);
    pointView1.setPointRadius(0.27);
    pointView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        pointView1SourceChanged(evt);
      }
    });

    jPanel1.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED)));
    jPanel1.setFont(standardFont);
    jPanel1.setLayout(new java.awt.BorderLayout());

    jPanel2.setFont(standardFont);
    jPanel2.setPreferredSize(new java.awt.Dimension(400, 200));
    jPanel2.setLayout(new javax.swing.BoxLayout(jPanel2, javax.swing.BoxLayout.Y_AXIS));

    objectPanel1.setPreferredSize(new java.awt.Dimension(200, 250));

    layeredScreen1.setCrossCursor(true);
    layeredScreen1.setMaxX(10.0);
    layeredScreen1.setMaxY(10.0);
    layeredScreen1.setMinX(-10.0);
    layeredScreen1.setMinY(-10.0);
    layeredScreen1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        layeredScreen1ValueChanged(evt);
      }
    });
    objectPanel1.add(layeredScreen1, java.awt.BorderLayout.CENTER);

    jPanel2.add(objectPanel1);

    outputPanel1.setBordered(true);
    outputPanel1.setLayout(new javax.swing.BoxLayout(outputPanel1, javax.swing.BoxLayout.Y_AXIS));

    vectorTextField1.setBordered(true);
    vectorTextField1.setHorizontal(true);
    vectorTextField1.setPadding(20);
    vectorTextField1.setUnit(new String[] {"", ""});
    outputPanel1.add(vectorTextField1);

    message1.setBordered(true);
    message1.setColumns(30);
    java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("physapps.mathematics.PolyFit", currentLocale); // NOI18N
    message1.setDescription(bundle.getString("s3")); // NOI18N
    outputPanel1.add(message1);

    jPanel2.add(outputPanel1);

    jPanel1.add(jPanel2, java.awt.BorderLayout.CENTER);

    inputPanel1.setLayout(new javax.swing.BoxLayout(inputPanel1, javax.swing.BoxLayout.Y_AXIS));

    pointEditor1.setAddButtonLabel(bundle.getString("pointEditorAdd")); // NOI18N
    pointEditor1.setChangeButtonLabel(bundle.getString("pointEditorChange")); // NOI18N
    pointEditor1.setClearLabel(bundle.getString("pointEditorClear")); // NOI18N
    pointEditor1.setModifyLabel(bundle.getString("pointEditorModify")); // NOI18N
    pointEditor1.setTextSlider1(textSlider1);
    pointEditor1.setTextSlider2(textSlider2);
    pointEditor1.setTitle(bundle.getString("pointEditorTitle")); // NOI18N
    pointEditor1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        pointEditor1SourceChanged(evt);
      }
    });
    inputPanel1.add(pointEditor1);

    textSlider1.setDescription("x =");
    textSlider1.setModel(new BoundedRealModel(-10.0,0.0,10.0));
    textSlider1.setUnit("");
    inputPanel1.add(textSlider1);

    textSlider2.setDescription("y =");
    textSlider2.setModel(new BoundedRealModel(-10.0,0.0,10.0));
    textSlider2.setUnit("");
    inputPanel1.add(textSlider2);

    integerTextSlider1.setDescription(bundle.getString("s1")); // NOI18N
    integerTextSlider1.setModel(new BoundedRealModel(0.0,3.0,10.0));
    integerTextSlider1.setUnit("");
    integerTextSlider1.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        integerTextSlider1PropertyChange(evt);
      }
    });
    inputPanel1.add(integerTextSlider1);

    jPanel1.add(inputPanel1, java.awt.BorderLayout.EAST);

    getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
  }// </editor-fold>//GEN-END:initComponents
  
  private void pointEditor1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_pointEditor1SourceChanged
    polynomialFitFunction1.setPoints(pointEditor1.getPoints());
    strideVector1.trigger();
    pointView1.setModel(pointEditor1.getPoints());
  }//GEN-LAST:event_pointEditor1SourceChanged
  
  private void pointView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_pointView1SourceChanged
    layeredScreen1.addView(pointView1);
    layeredScreen1.addView(functionView1);
  }//GEN-LAST:event_pointView1SourceChanged
  
  private void polynomialFunction1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_polynomialFunction1ValueChanged
    functionView1.setModel(strideVector1.getOutputVector(), polynomialFunction1.getOutputVector());
  }//GEN-LAST:event_polynomialFunction1ValueChanged
  
  private void polynomialFitFunction1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_polynomialFitFunction1ValueChanged
    polynomialFunction1.setPolynomial(polynomialFitFunction1.getPolynomial());
    message1.setMessage("" + polynomialFitFunction1.getPolynomial());
  }//GEN-LAST:event_polynomialFitFunction1ValueChanged
  
  private void layeredScreen1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_layeredScreen1ValueChanged
    vectorTextField1.setValue(layeredScreen1.getClickedPosition());
  }//GEN-LAST:event_layeredScreen1ValueChanged
  
  private void strideVector1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_strideVector1ValueChanged
    DVector vals = strideVector1.getOutputVector();
    polynomialFunction1.setInputVector(vals);
  }//GEN-LAST:event_strideVector1ValueChanged
  
  private void integerTextSlider1PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_integerTextSlider1PropertyChange
    polynomialFitFunction1.setDegree(integerTextSlider1.getValueAsInt());
    strideVector1.trigger();
  }//GEN-LAST:event_integerTextSlider1PropertyChange
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  protected physbeans.views.FunctionView functionView1;
  protected physbeans.inout.InputPanel inputPanel1;
  protected physbeans.inout.IntegerTextSlider integerTextSlider1;
  protected javax.swing.JPanel jPanel1;
  protected javax.swing.JPanel jPanel2;
  protected physbeans.inout.LayeredScreen layeredScreen1;
  protected physbeans.inout.Message message1;
  protected physbeans.inout.ObjectPanel objectPanel1;
  protected physbeans.inout.OutputPanel outputPanel1;
  protected physbeans.inout.PointEditor pointEditor1;
  protected physbeans.views.PointView pointView1;
  protected physbeans.func.PolynomialFitFunction polynomialFitFunction1;
  protected physbeans.func.PolynomialFunction polynomialFunction1;
  protected physbeans.func.StrideVector strideVector1;
  protected physbeans.inout.TextSlider textSlider1;
  protected physbeans.inout.TextSlider textSlider2;
  protected physbeans.inout.VectorTextField vectorTextField1;
  // End of variables declaration//GEN-END:variables
  
}
