package physapps.nonlinear;

import physbeans.inout.*;
import physbeans.math.*;
import physbeans.model.*;

/**
 * template for simulation applets<br>
 * contains an input, object and output panel
 */
public class DuffingOscillator extends PhysBeansApplet {

  static public void main(String[] args) {
    startApp(new DuffingOscillator(), 535, 555);
  }

  /** Creates new form Simulation */
  public void init() {
    setLocale();
    initComponents();
  }

  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    duffingOscillator1 = new physbeans.phys.DuffingOscillator();
    harmonicFunction1 = new physbeans.func.HarmonicFunction();
    multiplexer1 = new physbeans.func.Multiplexer();
    selector1 = new physbeans.func.Selector();
    duffingView1 = new physbeans.views.DuffingView();
    jPanel1 = new javax.swing.JPanel();
    jPanel2 = new javax.swing.JPanel();
    objectPanel1 = new physbeans.inout.ObjectPanel();
    layeredScreen1 = new physbeans.inout.LayeredScreen();
    outputPanel1 = new physbeans.inout.OutputPanel();
    oscilloscope1 = new physbeans.inout.Oscilloscope();
    inputPanel1 = new physbeans.inout.InputPanel();
    timer1 = new physbeans.inout.Timer();
    textSliderX0 = new physbeans.inout.TextSlider();
    textSliderV0 = new physbeans.inout.TextSlider();
    textSliderLambda = new physbeans.inout.TextSlider();
    textSliderNy = new physbeans.inout.TextSlider();
    textSliderA = new physbeans.inout.TextSlider();
    textSliderOmega = new physbeans.inout.TextSlider();
    switchBox1 = new physbeans.inout.SwitchBox();

    duffingOscillator1.setAbsoluteTolerance(1.0E-10);
    duffingOscillator1.setExternalForceFunction(harmonicFunction1);
    duffingOscillator1.setMu(-1.0);
    duffingOscillator1.setThrowStepsizeTooSmall(false);
    duffingOscillator1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        duffingOscillator1ValueChanged1(evt);
      }
    });

    harmonicFunction1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        harmonicFunction1ValueChanged1(evt);
      }
    });

    multiplexer1.setInputLength(3);
    multiplexer1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        multiplexer1ValueChanged(evt);
        multiplexer1ValueChanged1(evt);
      }
    });

    selector1.setIndex(new int[]{0,2});
    selector1.setInputLength(3);
    selector1.setOutputVector(DVector.valueOf("[0.0,0.0]"));
    selector1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        selector1ValueChanged(evt);
      }
    });

    duffingView1.setFScale(0.5);
    duffingView1.setInitialValues(DVector.valueOf("[0.0,0.07]"));
    duffingView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        duffingView1SourceChanged(evt);
      }
    });

    jPanel1.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED)));
    jPanel1.setFont(standardFont);
    jPanel1.setLayout(new java.awt.BorderLayout());

    jPanel2.setFont(standardFont);
    jPanel2.setLayout(new javax.swing.BoxLayout(jPanel2, javax.swing.BoxLayout.Y_AXIS));

    layeredScreen1.setBackground(new java.awt.Color(255, 255, 255));
    layeredScreen1.setBordered(true);
    layeredScreen1.setMaxX(0.8);
    layeredScreen1.setMaxY(0.1);
    layeredScreen1.setMinX(-0.8);
    layeredScreen1.setMinY(-1.1);
    layeredScreen1.setOpaque(true);
    objectPanel1.add(layeredScreen1, java.awt.BorderLayout.CENTER);

    jPanel2.add(objectPanel1);

    oscilloscope1.setNLines(3);
    oscilloscope1.setMaxY(0.5);
    oscilloscope1.setMinY(-0.5);
    java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("physapps.nonlinear.DuffingOscillator", currentLocale); // NOI18N
    oscilloscope1.setPositionLabel(bundle.getString("osciPosition")); // NOI18N
    oscilloscope1.setScaleLabel(bundle.getString("osciScale")); // NOI18N
    oscilloscope1.setTimePerTick(0.3);
    outputPanel1.add(oscilloscope1);

    jPanel2.add(outputPanel1);

    jPanel1.add(jPanel2, java.awt.BorderLayout.CENTER);

    inputPanel1.setLayout(new javax.swing.BoxLayout(inputPanel1, javax.swing.BoxLayout.Y_AXIS));

    timer1.setDelay(15L);
    timer1.setExplanation(bundle.getString("timerLabel")); // NOI18N
    timer1.setTimeIncrement(0.3);
    timer1.addTimerListener(new physbeans.event.TimerListener() {
      public void nextStep(physbeans.event.NextStepEvent evt) {
        timer1NextStep(evt);
      }
      public void restart(physbeans.event.RestartEvent evt) {
        timer1Restart(evt);
      }
    });
    inputPanel1.add(timer1);

    textSliderX0.setDescription("x(0) =");
    textSliderX0.setModel(new BoundedRealModel(-1.0,0.0,1.0));
    textSliderX0.setUnit("");
    textSliderX0.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSliderX0PropertyChange(evt);
      }
    });
    inputPanel1.add(textSliderX0);

    textSliderV0.setDescription("dx/dt(0) =");
    textSliderV0.setModel(new BoundedRealModel(-3.0,0.0,3.0));
    textSliderV0.setUnit("");
    textSliderV0.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSliderV0PropertyChange(evt);
      }
    });
    inputPanel1.add(textSliderV0);

    textSliderLambda.setDescription("\u03bb =");
    textSliderLambda.setModel(new BoundedRealModel(0.0,0.316228,2.0));
    textSliderLambda.setUnit("");
    textSliderLambda.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSliderLambdaPropertyChange(evt);
      }
    });
    inputPanel1.add(textSliderLambda);

    textSliderNy.setDescription("\u03bd =");
    textSliderNy.setModel(new BoundedRealModel(0.0,10.0,20.0));
    textSliderNy.setUnit("");
    textSliderNy.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSliderNyPropertyChange(evt);
      }
    });
    inputPanel1.add(textSliderNy);

    textSliderA.setDescription("A =");
    textSliderA.setModel(new BoundedRealModel(0.0,0.07,0.3));
    textSliderA.setUnit("");
    textSliderA.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSliderAPropertyChange(evt);
        textSliderAPropertyChange1(evt);
      }
    });
    inputPanel1.add(textSliderA);

    textSliderOmega.setDescription("\u03c9_ext =");
    textSliderOmega.setModel(new BoundedRealModel(0.0,1.106797,2.0));
    textSliderOmega.setUnit("");
    textSliderOmega.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSliderOmegaPropertyChange(evt);
      }
    });
    inputPanel1.add(textSliderOmega);

    switchBox1.setBoxLabel( new String[] {
      java.util.ResourceBundle.getBundle("physapps.nonlinear.DuffingOscillator", currentLocale).getString("s1"),
      java.util.ResourceBundle.getBundle("physapps.nonlinear.DuffingOscillator", currentLocale).getString("s2"),
      java.util.ResourceBundle.getBundle("physapps.nonlinear.DuffingOscillator", currentLocale).getString("s3")
    });
    switchBox1.setTitle(bundle.getString("s4")); // NOI18N
    switchBox1.addSwitchListener(new physbeans.event.SwitchListener() {
      public void valueChanged(physbeans.event.SwitchEvent evt) {
        switchBox1ValueChanged(evt);
      }
    });
    inputPanel1.add(switchBox1);

    jPanel1.add(inputPanel1, java.awt.BorderLayout.EAST);

    getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
  }// </editor-fold>//GEN-END:initComponents

  private void textSliderNyPropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSliderNyPropertyChange
    duffingOscillator1.setNu(textSliderNy.getValue());
}//GEN-LAST:event_textSliderNyPropertyChange

  private void textSliderAPropertyChange1(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSliderAPropertyChange1
    duffingView1.setInitialValue(1, textSliderA.getValue());
}//GEN-LAST:event_textSliderAPropertyChange1

  private void harmonicFunction1ValueChanged1(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_harmonicFunction1ValueChanged1
    multiplexer1.singleInputValue(2, harmonicFunction1.getOutputValue());
  }//GEN-LAST:event_harmonicFunction1ValueChanged1

  private void duffingOscillator1ValueChanged1(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_duffingOscillator1ValueChanged1
    multiplexer1.singleInputValue(0, duffingOscillator1.getX());
    multiplexer1.singleInputValue(1, duffingOscillator1.getV());
}//GEN-LAST:event_duffingOscillator1ValueChanged1

  private void multiplexer1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_multiplexer1ValueChanged
    selector1.setInputVector(multiplexer1.getOutputVector());
  }//GEN-LAST:event_multiplexer1ValueChanged

  private void duffingView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_duffingView1SourceChanged
    layeredScreen1.addView(duffingView1);
  }//GEN-LAST:event_duffingView1SourceChanged

  private void textSliderOmegaPropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSliderOmegaPropertyChange
    harmonicFunction1.setOmega(textSliderOmega.getValue());
}//GEN-LAST:event_textSliderOmegaPropertyChange

  private void textSliderAPropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSliderAPropertyChange
    harmonicFunction1.setAmplitude(textSliderA.getValue());
}//GEN-LAST:event_textSliderAPropertyChange

  private void textSliderLambdaPropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSliderLambdaPropertyChange
    duffingOscillator1.setLambda(textSliderLambda.getValue());
}//GEN-LAST:event_textSliderLambdaPropertyChange

  private void textSliderV0PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSliderV0PropertyChange
    duffingOscillator1.setV0(textSliderV0.getValue());
}//GEN-LAST:event_textSliderV0PropertyChange

  private void textSliderX0PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSliderX0PropertyChange
    double val = textSliderX0.getValue();
    duffingOscillator1.setX0(val);
    duffingView1.setInitialValue(0, val);
}//GEN-LAST:event_textSliderX0PropertyChange

  private void timer1Restart(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart
    duffingOscillator1.restart();
    duffingView1.restart();
    oscilloscope1.restart();
  }//GEN-LAST:event_timer1Restart

  private void timer1NextStep(physbeans.event.NextStepEvent evt) {//GEN-FIRST:event_timer1NextStep
    duffingOscillator1.setTime(timer1.getTime());
    harmonicFunction1.setInputValue(timer1.getTime());
  }//GEN-LAST:event_timer1NextStep

  private void switchBox1ValueChanged(physbeans.event.SwitchEvent evt) {//GEN-FIRST:event_switchBox1ValueChanged
    oscilloscope1.setLineActive(switchBox1.getSelected());
}//GEN-LAST:event_switchBox1ValueChanged

  private void selector1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_selector1ValueChanged
    duffingView1.setModel(selector1.getOutputVector());
  }//GEN-LAST:event_selector1ValueChanged

  private void multiplexer1ValueChanged1(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_multiplexer1ValueChanged1
    oscilloscope1.setInputVector(multiplexer1.getOutputVector());
  }//GEN-LAST:event_multiplexer1ValueChanged1

  // Variables declaration - do not modify//GEN-BEGIN:variables
  protected physbeans.phys.DuffingOscillator duffingOscillator1;
  protected physbeans.views.DuffingView duffingView1;
  protected physbeans.func.HarmonicFunction harmonicFunction1;
  protected physbeans.inout.InputPanel inputPanel1;
  protected javax.swing.JPanel jPanel1;
  protected javax.swing.JPanel jPanel2;
  protected physbeans.inout.LayeredScreen layeredScreen1;
  protected physbeans.func.Multiplexer multiplexer1;
  protected physbeans.inout.ObjectPanel objectPanel1;
  protected physbeans.inout.Oscilloscope oscilloscope1;
  protected physbeans.inout.OutputPanel outputPanel1;
  protected physbeans.func.Selector selector1;
  protected physbeans.inout.SwitchBox switchBox1;
  protected physbeans.inout.TextSlider textSliderA;
  protected physbeans.inout.TextSlider textSliderLambda;
  protected physbeans.inout.TextSlider textSliderNy;
  protected physbeans.inout.TextSlider textSliderOmega;
  protected physbeans.inout.TextSlider textSliderV0;
  protected physbeans.inout.TextSlider textSliderX0;
  protected physbeans.inout.Timer timer1;
  // End of variables declaration//GEN-END:variables
}
