package physapps.nonlinear;

import javax.swing.*;
import java.awt.*;
import physbeans.inout.*;
import physbeans.func.*;
import physbeans.math.*;
import physbeans.model.*;

/**
 * template for simulation applets<br>
 * contains an input, object and output panel
 */
public class PhaseDuffingOscillator extends PhysBeansApplet {
  
  static public void main(String[] args) {
    startApp(new PhaseDuffingOscillator(), 535, 500);
  }
  
  /** Creates new form Simulation */
  public void init() {
    setLocale();
    initComponents();
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    duffingOscillator1 = new physbeans.phys.DuffingOscillator();
    harmonicFunction1 = new physbeans.func.HarmonicFunction();
    multiplexer1 = new physbeans.func.Multiplexer();
    duffingView1 = new physbeans.views.DuffingView();
    jPanel1 = new javax.swing.JPanel();
    jPanel2 = new javax.swing.JPanel();
    objectPanel1 = new physbeans.inout.ObjectPanel();
    layeredScreen1 = new physbeans.inout.LayeredScreen();
    outputPanel1 = new physbeans.inout.OutputPanel();
    xYScope1 = new physbeans.inout.XYScope();
    inputPanel1 = new physbeans.inout.InputPanel();
    timer1 = new physbeans.inout.Timer();
    textSlider1 = new physbeans.inout.TextSlider();
    textSlider2 = new physbeans.inout.TextSlider();
    textSlider3 = new physbeans.inout.TextSlider();
    textSlider6 = new physbeans.inout.TextSlider();
    textSlider4 = new physbeans.inout.TextSlider();
    textSlider5 = new physbeans.inout.TextSlider();

    duffingOscillator1.setAbsoluteTolerance(1.0E-10);
    duffingOscillator1.setExternalForceFunction(harmonicFunction1);
    duffingOscillator1.setMu(-1.0);
    duffingOscillator1.setThrowStepsizeTooSmall(false);
    duffingOscillator1.setX0(0.0);
    duffingOscillator1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        duffingOscillator1ValueChanged1(evt);
        duffingOscillator1ValueChanged2(evt);
      }
    });

    harmonicFunction1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        harmonicFunction1ValueChanged1(evt);
      }
    });

    multiplexer1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        multiplexer1ValueChanged(evt);
      }
    });

    duffingView1.setFScale(0.5);
    duffingView1.setInitialValues(DVector.valueOf("[0.0,0.07]"));
    duffingView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        duffingView1SourceChanged(evt);
      }
    });

    jPanel1.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED)));
    jPanel1.setFont(standardFont);
    jPanel1.setLayout(new java.awt.BorderLayout());

    jPanel2.setFont(standardFont);
    jPanel2.setLayout(new javax.swing.BoxLayout(jPanel2, javax.swing.BoxLayout.Y_AXIS));

    layeredScreen1.setBackground(new java.awt.Color(255, 255, 255));
    layeredScreen1.setBordered(true);
    layeredScreen1.setMaxX(0.8);
    layeredScreen1.setMaxY(0.1);
    layeredScreen1.setMinX(-0.8);
    layeredScreen1.setMinY(-1.1);
    layeredScreen1.setOpaque(true);
    objectPanel1.add(layeredScreen1, java.awt.BorderLayout.CENTER);

    jPanel2.add(objectPanel1);

    xYScope1.setBufferSize(4000);
    xYScope1.setMaxX(0.6);
    xYScope1.setMaxY(0.32);
    xYScope1.setMinX(-0.6);
    xYScope1.setMinY(-0.32);
    java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("physapps.nonlinear.PhaseDuffingOscillator", currentLocale); // NOI18N
    xYScope1.setPositionLabel(bundle.getString("osciPosition")); // NOI18N
    xYScope1.setScaleLabel(bundle.getString("osciScale")); // NOI18N
    xYScope1.setScaleX(true);
    outputPanel1.add(xYScope1);

    jPanel2.add(outputPanel1);

    jPanel1.add(jPanel2, java.awt.BorderLayout.CENTER);

    inputPanel1.setLayout(new javax.swing.BoxLayout(inputPanel1, javax.swing.BoxLayout.Y_AXIS));

    timer1.setDelay(15L);
    timer1.setExplanation(bundle.getString("timerLabel")); // NOI18N
    timer1.addTimerListener(new physbeans.event.TimerListener() {
      public void nextStep(physbeans.event.NextStepEvent evt) {
        timer1NextStep(evt);
        timer1NextStep1(evt);
      }
      public void restart(physbeans.event.RestartEvent evt) {
        timer1Restart(evt);
        timer1Restart1(evt);
      }
    });
    inputPanel1.add(timer1);

    textSlider1.setDescription("x(0) =");
    textSlider1.setModel(new BoundedRealModel(-1.0,0.0,1.0));
    textSlider1.setUnit("");
    textSlider1.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider1PropertyChange(evt);
      }
    });
    inputPanel1.add(textSlider1);

    textSlider2.setDescription("dx/dt(0) =");
    textSlider2.setModel(new BoundedRealModel(-3.0,0.0,3.0));
    textSlider2.setUnit("");
    textSlider2.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider2PropertyChange(evt);
      }
    });
    inputPanel1.add(textSlider2);

    textSlider3.setDescription("\u03bb =");
    textSlider3.setModel(new BoundedRealModel(0.0,0.316228,2.0));
    textSlider3.setUnit("");
    textSlider3.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider3PropertyChange(evt);
      }
    });
    inputPanel1.add(textSlider3);

    textSlider6.setDescription("\u03bd =");
    textSlider6.setModel(new BoundedRealModel(0.0,10.0,20.0));
    textSlider6.setUnit("");
    textSlider6.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider6PropertyChange(evt);
      }
    });
    inputPanel1.add(textSlider6);

    textSlider4.setDescription("A =");
    textSlider4.setModel(new BoundedRealModel(0.0,0.07,0.3));
    textSlider4.setUnit("");
    textSlider4.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider4PropertyChange(evt);
        textSlider4PropertyChange1(evt);
      }
    });
    inputPanel1.add(textSlider4);

    textSlider5.setDescription("\u03c9_ext =");
    textSlider5.setModel(new BoundedRealModel(0.0,1.106797,2.0));
    textSlider5.setUnit("");
    textSlider5.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider5PropertyChange(evt);
      }
    });
    inputPanel1.add(textSlider5);

    jPanel1.add(inputPanel1, java.awt.BorderLayout.EAST);

    getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
  }// </editor-fold>//GEN-END:initComponents

  private void textSlider6PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider6PropertyChange
    duffingOscillator1.setNu(textSlider6.getValue());
  }//GEN-LAST:event_textSlider6PropertyChange

  private void textSlider4PropertyChange1(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider4PropertyChange1
    duffingView1.setInitialValue(1, textSlider4.getValue());
  }//GEN-LAST:event_textSlider4PropertyChange1

  private void harmonicFunction1ValueChanged1(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_harmonicFunction1ValueChanged1
    multiplexer1.singleInputValue(1, harmonicFunction1.getOutputValue());
  }//GEN-LAST:event_harmonicFunction1ValueChanged1

  private void duffingOscillator1ValueChanged2(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_duffingOscillator1ValueChanged2
    multiplexer1.singleInputValue(0, duffingOscillator1.getX());
  }//GEN-LAST:event_duffingOscillator1ValueChanged2

  private void multiplexer1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_multiplexer1ValueChanged
    duffingView1.setModel(multiplexer1.getOutputVector());
  }//GEN-LAST:event_multiplexer1ValueChanged
  
  private void duffingView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_duffingView1SourceChanged
    layeredScreen1.addView(duffingView1);
  }//GEN-LAST:event_duffingView1SourceChanged
  
  private void duffingOscillator1ValueChanged1(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_duffingOscillator1ValueChanged1
    xYScope1.setInputVector(duffingOscillator1.getOutputVector());
  }//GEN-LAST:event_duffingOscillator1ValueChanged1
      
  private void textSlider5PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider5PropertyChange
    harmonicFunction1.setOmega(textSlider5.getValue());
  }//GEN-LAST:event_textSlider5PropertyChange
  
  private void textSlider4PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider4PropertyChange
    harmonicFunction1.setAmplitude(textSlider4.getValue());
  }//GEN-LAST:event_textSlider4PropertyChange
  
  private void textSlider3PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider3PropertyChange
    duffingOscillator1.setLambda(textSlider3.getValue());
  }//GEN-LAST:event_textSlider3PropertyChange
  
  private void textSlider2PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider2PropertyChange
    duffingOscillator1.setV0(textSlider2.getValue());
  }//GEN-LAST:event_textSlider2PropertyChange
  
  private void textSlider1PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider1PropertyChange
    double val = textSlider1.getValue();
    duffingOscillator1.setX0(val);
    duffingView1.setInitialValue(0, val);
  }//GEN-LAST:event_textSlider1PropertyChange
  
  private void timer1Restart1(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart1
    xYScope1.restart();
  }//GEN-LAST:event_timer1Restart1
  
  private void timer1Restart(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart
    duffingOscillator1.restart();
    duffingView1.restart();
  }//GEN-LAST:event_timer1Restart
  
  private void timer1NextStep1(physbeans.event.NextStepEvent evt) {//GEN-FIRST:event_timer1NextStep1
    harmonicFunction1.setInputValue(timer1.getTime());
  }//GEN-LAST:event_timer1NextStep1
  
  private void timer1NextStep(physbeans.event.NextStepEvent evt) {//GEN-FIRST:event_timer1NextStep
    duffingOscillator1.setTime(timer1.getTime());
  }//GEN-LAST:event_timer1NextStep
  
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  protected physbeans.phys.DuffingOscillator duffingOscillator1;
  protected physbeans.views.DuffingView duffingView1;
  protected physbeans.func.HarmonicFunction harmonicFunction1;
  protected physbeans.inout.InputPanel inputPanel1;
  protected javax.swing.JPanel jPanel1;
  protected javax.swing.JPanel jPanel2;
  protected physbeans.inout.LayeredScreen layeredScreen1;
  protected physbeans.func.Multiplexer multiplexer1;
  protected physbeans.inout.ObjectPanel objectPanel1;
  protected physbeans.inout.OutputPanel outputPanel1;
  protected physbeans.inout.TextSlider textSlider1;
  protected physbeans.inout.TextSlider textSlider2;
  protected physbeans.inout.TextSlider textSlider3;
  protected physbeans.inout.TextSlider textSlider4;
  protected physbeans.inout.TextSlider textSlider5;
  protected physbeans.inout.TextSlider textSlider6;
  protected physbeans.inout.Timer timer1;
  protected physbeans.inout.XYScope xYScope1;
  // End of variables declaration//GEN-END:variables
  
}
