package physapps.nuclearphysics;

import javax.swing.*;
import java.awt.*;
import physbeans.inout.*;
import physbeans.math.*;
import physbeans.model.*;

/**
 * template for simulation applets<br>
 * contains an input, object and output panel<br>
 *
 */
public class RadioactiveChain extends PhysBeansApplet {
  
  static public void main(String[] args) {
    startApp(new RadioactiveChain(), 570, 500);
  }
  
  /** Creates new form Simulation */
  public void init() {
    setLocale();
    initComponents();
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
// <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
  private void initComponents() {
    radioactiveDecayChain1 = new physbeans.phys.RadioactiveDecayChain();
    scalingFunction1 = new physbeans.func.ScalingFunction();
    mergeFunction1 = new physbeans.func.MergeFunction();
    barView1 = new physbeans.views.BarView();
    labelView1 = new physbeans.views.LabelView();
    labelView2 = new physbeans.views.LabelView();
    jPanel1 = new javax.swing.JPanel();
    jPanel2 = new javax.swing.JPanel();
    objectPanel1 = new physbeans.inout.ObjectPanel();
    layeredScreen1 = new physbeans.inout.LayeredScreen();
    outputPanel1 = new physbeans.inout.OutputPanel();
    oscilloscope1 = new physbeans.inout.Oscilloscope();
    inputPanel1 = new physbeans.inout.InputPanel();
    timer1 = new physbeans.inout.Timer();
    textSlider1 = new physbeans.inout.TextSlider();
    textSlider2 = new physbeans.inout.TextSlider();
    textSlider3 = new physbeans.inout.TextSlider();
    switchBox1 = new physbeans.inout.SwitchBox();
    switchBox2 = new physbeans.inout.SwitchBox();
    
    radioactiveDecayChain1.setInitialValues(DVector.valueOf("[1.0,0.0,0.0,0.0]"));
    radioactiveDecayChain1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        radioactiveDecayChain1ValueChanged(evt);
        radioactiveDecayChain1ValueChanged2(evt);
        radioactiveDecayChain1ValueChanged3(evt);
        radioactiveDecayChain1ValueChanged1(evt);
      }
    });
    
    scalingFunction1.setXMin(1.0E-7);
    scalingFunction1.setYMax(1.0);
    scalingFunction1.setLogarithmic(true);
    scalingFunction1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        scalingFunction1ValueChanged(evt);
      }
    });
    
    mergeFunction1.setUseFirstVector(new boolean[]{false});
    mergeFunction1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        mergeFunction1ValueChanged(evt);
      }
    });
    
    barView1.setEqualBarColor(false);
    barView1.setInitialValues(DVector.valueOf("[1.0,0.0,0.0,0.0]"));
    barView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        barView1SourceChanged(evt);
      }
    });
    
    labelView1.setDepth(40);
    labelView1.setInitialValues(new String[] {"1.0", "0.0", "0.0", "0.0"});
    labelView1.setMarginLeft(0.35);
    labelView1.setMarginRight(0.35);
    labelView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        labelView1SourceChanged(evt);
      }
    });
    
    labelView2.setDepth(30);
    labelView2.setInitialValues(new String[] {"N1", "N2", "N3", "N4"});
    labelView2.setMarginLeft(0.35);
    labelView2.setMarginRight(0.35);
    labelView2.setPosition(1.0);
    labelView2.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        labelView2SourceChanged(evt);
      }
    });
    
    
    jPanel1.setLayout(new java.awt.BorderLayout());
    
    jPanel1.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED)));
    jPanel1.setFont(standardFont);
    jPanel2.setLayout(new javax.swing.BoxLayout(jPanel2, javax.swing.BoxLayout.Y_AXIS));
    
    jPanel2.setFont(standardFont);
    layeredScreen1.setBackground(java.awt.Color.white);
    layeredScreen1.setMaxX(4.2);
    layeredScreen1.setMaxY(1.07);
    layeredScreen1.setMinX(-0.5);
    layeredScreen1.setMinY(-0.08);
    layeredScreen1.setOpaque(true);
    objectPanel1.add(layeredScreen1, java.awt.BorderLayout.CENTER);
    
    jPanel2.add(objectPanel1);
    
    oscilloscope1.setNLines(4);
    oscilloscope1.setLineActive(new boolean[]{true,true,true,true});
    oscilloscope1.setMinY(0.0);
    oscilloscope1.setPositionLabel(java.util.ResourceBundle.getBundle("physapps.nuclearphysics.RadioactiveChain", currentLocale).getString("osciPosition"));
    oscilloscope1.setScaleLabel(java.util.ResourceBundle.getBundle("physapps.nuclearphysics.RadioactiveChain", currentLocale).getString("osciScale"));
    oscilloscope1.setTimePerTick(100.0);
    outputPanel1.add(oscilloscope1);
    
    jPanel2.add(outputPanel1);
    
    jPanel1.add(jPanel2, java.awt.BorderLayout.CENTER);
    
    inputPanel1.setLayout(new javax.swing.BoxLayout(inputPanel1, javax.swing.BoxLayout.Y_AXIS));
    
    timer1.setDelay(25L);
    timer1.setExplanation(java.util.ResourceBundle.getBundle("physapps.nuclearphysics.RadioactiveChain", currentLocale).getString("timerLabel"));
    timer1.setTimeIncrement(100.0);
    timer1.addTimerListener(new physbeans.event.TimerListener() {
      public void nextStep(physbeans.event.NextStepEvent evt) {
        timer1NextStep(evt);
      }
      public void restart(physbeans.event.RestartEvent evt) {
        timer1Restart(evt);
      }
    });
    
    inputPanel1.add(timer1);
    
    textSlider1.setColumns(7);
    textSlider1.setDescription("T\u00bd(1) =");
    textSlider1.setLogarithmic(true);
    textSlider1.setModel(new BoundedRealModel(100.0,10000.0,1.0E10));
    textSlider1.setUnit("a");
    textSlider1.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider1PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider1);
    
    textSlider2.setColumns(7);
    textSlider2.setDescription("T\u00bd(2) =");
    textSlider2.setLogarithmic(true);
    textSlider2.setModel(new BoundedRealModel(100.0,10000.0,1.0E10));
    textSlider2.setUnit("a");
    textSlider2.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider2PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider2);
    
    textSlider3.setColumns(7);
    textSlider3.setDescription("T\u00bd(3) =");
    textSlider3.setLogarithmic(true);
    textSlider3.setModel(new BoundedRealModel(100.0,10000.0,1.0E10));
    textSlider3.setUnit("a");
    textSlider3.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider3PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider3);
    
    switchBox1.setBoxLabel(new String[] {
      java.util.ResourceBundle.getBundle("physapps.nuclearphysics.RadioactiveChain", currentLocale).getString("s6")
    });
    switchBox1.setSelected(new boolean[]{false});
    switchBox1.setTitle("");
    switchBox1.addSwitchListener(new physbeans.event.SwitchListener() {
      public void valueChanged(physbeans.event.SwitchEvent evt) {
        switchBox1ValueChanged(evt);
      }
    });
    
    inputPanel1.add(switchBox1);
    
    switchBox2.setBoxLabel(new String[] {
      java.util.ResourceBundle.getBundle("physapps.nuclearphysics.RadioactiveChain", currentLocale).getString("s1"),
      java.util.ResourceBundle.getBundle("physapps.nuclearphysics.RadioactiveChain", currentLocale).getString("s2"),
      java.util.ResourceBundle.getBundle("physapps.nuclearphysics.RadioactiveChain", currentLocale).getString("s3"),
      java.util.ResourceBundle.getBundle("physapps.nuclearphysics.RadioactiveChain", currentLocale).getString("s4")
    });
    switchBox2.setSelected(new boolean[]{true,true,true,true});
    switchBox2.setTitle(java.util.ResourceBundle.getBundle("physapps.nuclearphysics.RadioactiveChain", currentLocale).getString("s5"));
    switchBox2.addSwitchListener(new physbeans.event.SwitchListener() {
      public void valueChanged(physbeans.event.SwitchEvent evt) {
        switchBox2ValueChanged(evt);
      }
    });
    
    inputPanel1.add(switchBox2);
    
    jPanel1.add(inputPanel1, java.awt.BorderLayout.EAST);
    
    getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
    
  }// </editor-fold>//GEN-END:initComponents

  private void radioactiveDecayChain1ValueChanged1(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_radioactiveDecayChain1ValueChanged1
    mergeFunction1.setSecondVector(radioactiveDecayChain1.getOutputVector());
  }//GEN-LAST:event_radioactiveDecayChain1ValueChanged1

  private void switchBox1ValueChanged(physbeans.event.SwitchEvent evt) {//GEN-FIRST:event_switchBox1ValueChanged
    mergeFunction1.setUseFirstVector(switchBox1.getSelected());
  }//GEN-LAST:event_switchBox1ValueChanged

  private void mergeFunction1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_mergeFunction1ValueChanged
    barView1.setModel(mergeFunction1.getOutputVector());
  }//GEN-LAST:event_mergeFunction1ValueChanged

  private void scalingFunction1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_scalingFunction1ValueChanged
    mergeFunction1.setFirstVector(scalingFunction1.getOutputVector());
  }//GEN-LAST:event_scalingFunction1ValueChanged

  private void radioactiveDecayChain1ValueChanged3(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_radioactiveDecayChain1ValueChanged3
    scalingFunction1.setInputVector(radioactiveDecayChain1.getOutputVector());
  }//GEN-LAST:event_radioactiveDecayChain1ValueChanged3

  private void radioactiveDecayChain1ValueChanged2(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_radioactiveDecayChain1ValueChanged2
    labelView1.setValues(radioactiveDecayChain1.getOutputVector());
  }//GEN-LAST:event_radioactiveDecayChain1ValueChanged2

  private void labelView2SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_labelView2SourceChanged
    layeredScreen1.addView(labelView2);
  }//GEN-LAST:event_labelView2SourceChanged

  private void labelView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_labelView1SourceChanged
    layeredScreen1.addView(labelView1);
  }//GEN-LAST:event_labelView1SourceChanged

  private void barView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_barView1SourceChanged
    layeredScreen1.addView(barView1);
  }//GEN-LAST:event_barView1SourceChanged
    
  private void timer1NextStep(physbeans.event.NextStepEvent evt) {//GEN-FIRST:event_timer1NextStep
    radioactiveDecayChain1.setTime(timer1.getTime());
  }//GEN-LAST:event_timer1NextStep
  
  private void radioactiveDecayChain1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_radioactiveDecayChain1ValueChanged
    DVector val = radioactiveDecayChain1.getOutputVector();
    oscilloscope1.setInputVector(val);
  }//GEN-LAST:event_radioactiveDecayChain1ValueChanged
  
  private void switchBox2ValueChanged(physbeans.event.SwitchEvent evt) {//GEN-FIRST:event_switchBox2ValueChanged
    oscilloscope1.setLineActive(switchBox2.getSelected());
  }//GEN-LAST:event_switchBox2ValueChanged
    
  private void textSlider3PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider3PropertyChange
    radioactiveDecayChain1.setTHalf(2, textSlider3.getValue());
  }//GEN-LAST:event_textSlider3PropertyChange
  
  private void textSlider2PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider2PropertyChange
    radioactiveDecayChain1.setTHalf(1, textSlider2.getValue());
  }//GEN-LAST:event_textSlider2PropertyChange
  
  private void textSlider1PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider1PropertyChange
    radioactiveDecayChain1.setTHalf(0, textSlider1.getValue());
  }//GEN-LAST:event_textSlider1PropertyChange
  
  private void timer1Restart(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart
    radioactiveDecayChain1.restart();
    oscilloscope1.restart();
    barView1.restart();
    labelView1.restart();
  }//GEN-LAST:event_timer1Restart
  
  
// Variables declaration - do not modify//GEN-BEGIN:variables
  protected physbeans.views.BarView barView1;
  protected physbeans.inout.InputPanel inputPanel1;
  protected javax.swing.JPanel jPanel1;
  protected javax.swing.JPanel jPanel2;
  protected physbeans.views.LabelView labelView1;
  protected physbeans.views.LabelView labelView2;
  protected physbeans.inout.LayeredScreen layeredScreen1;
  protected physbeans.func.MergeFunction mergeFunction1;
  protected physbeans.inout.ObjectPanel objectPanel1;
  protected physbeans.inout.Oscilloscope oscilloscope1;
  protected physbeans.inout.OutputPanel outputPanel1;
  protected physbeans.phys.RadioactiveDecayChain radioactiveDecayChain1;
  protected physbeans.func.ScalingFunction scalingFunction1;
  protected physbeans.inout.SwitchBox switchBox1;
  protected physbeans.inout.SwitchBox switchBox2;
  protected physbeans.inout.TextSlider textSlider1;
  protected physbeans.inout.TextSlider textSlider2;
  protected physbeans.inout.TextSlider textSlider3;
  protected physbeans.inout.Timer timer1;
// End of variables declaration//GEN-END:variables
  
}
