package physapps.optics;

import javax.swing.*;
import java.awt.*;
import physbeans.inout.*;
import physbeans.model.*;
import physbeans.math.*;

/**
 * template for simulation applets<br>
 * contains an input, object and output panel
 */
public class GradientFibre extends PhysBeansApplet {
  
  static public void main(String[] args) {
    startApp(new GradientFibre(), 540, 540);
  }
  
  /** Creates new form Simulation */
  public void init() {
    setLocale();
    initComponents();
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
// <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
  private void initComponents() {
    pointLightSource1 = new physbeans.phys.PointLightSource();
    singlePlane1 = new physbeans.phys.SinglePlane();
    singlePlane2 = new physbeans.phys.SinglePlane();
    singlePlane3 = new physbeans.phys.SinglePlane();
    singlePlane4 = new physbeans.phys.SinglePlane();
    singlePlane5 = new physbeans.phys.SinglePlane();
    singlePlane6 = new physbeans.phys.SinglePlane();
    singlePlane7 = new physbeans.phys.SinglePlane();
    singlePlane8 = new physbeans.phys.SinglePlane();
    opticalBench1 = new physbeans.phys.OpticalBench();
    pointLightSourceView1 = new physbeans.views.PointLightSourceView();
    simpleFigureView1 = new physbeans.views.SimpleFigureView();
    simpleFigureView2 = new physbeans.views.SimpleFigureView();
    simpleFigureView3 = new physbeans.views.SimpleFigureView();
    simpleFigureView4 = new physbeans.views.SimpleFigureView();
    simpleFigureView5 = new physbeans.views.SimpleFigureView();
    jPanel1 = new javax.swing.JPanel();
    jPanel2 = new javax.swing.JPanel();
    objectPanel1 = new physbeans.inout.ObjectPanel();
    layeredScreen1 = new physbeans.inout.LayeredScreen();
    outputPanel1 = new physbeans.inout.OutputPanel();
    vectorTextField1 = new physbeans.inout.VectorTextField();
    inputPanel1 = new physbeans.inout.InputPanel();
    textSlider1 = new physbeans.inout.TextSlider();
    textSlider2 = new physbeans.inout.TextSlider();
    textSlider3 = new physbeans.inout.TextSlider();
    textSlider4 = new physbeans.inout.TextSlider();
    textSlider5 = new physbeans.inout.TextSlider();
    
    pointLightSource1.setNRays(9);
    pointLightSource1.setHeight(-4.0);
    pointLightSource1.setMidAngle(Math.PI/2D);
    pointLightSource1.setSpreadAngle(1.0);
    pointLightSource1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        pointLightSource1SourceChanged(evt);
      }
    });
    
    singlePlane1.setPosition(-1.0);
    singlePlane1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        singlePlane1SourceChanged(evt);
      }
    });
    
    singlePlane2.setPosition(1.0);
    singlePlane2.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        singlePlane2SourceChanged(evt);
      }
    });
    
    singlePlane3.setPosition(-1.5);
    singlePlane3.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        singlePlane3SourceChanged(evt);
      }
    });
    
    singlePlane4.setPosition(1.5);
    singlePlane4.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        singlePlane4SourceChanged(evt);
      }
    });
    
    singlePlane5.setPosition(-2.0);
    singlePlane5.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        singlePlane5SourceChanged(evt);
      }
    });
    
    singlePlane6.setPosition(2.0);
    singlePlane6.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        singlePlane6SourceChanged(evt);
      }
    });
    
    singlePlane7.setPosition(-2.5);
    singlePlane7.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        singlePlane7SourceChanged(evt);
      }
    });
    
    singlePlane8.setPosition(2.5);
    singlePlane8.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        singlePlane8SourceChanged(evt);
      }
    });
    
    pointLightSourceView1.setDepth(30);
    pointLightSourceView1.setDiameter(0.3);
    simpleFigureView1.setColor(java.awt.Color.white);
    simpleFigureView1.setDepth(80);
    simpleFigureView1.setFigureType(5);
    simpleFigureView1.setFilled(true);
    simpleFigureView1.setP1(DVector.valueOf("[-2.5,-5.0]"));
    simpleFigureView1.setP2(DVector.valueOf("[2.5,5.0]"));
    simpleFigureView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        simpleFigureView1SourceChanged(evt);
      }
    });
    
    simpleFigureView2.setDepth(70);
    simpleFigureView2.setFigureType(1);
    simpleFigureView2.setP1(DVector.valueOf("[-2.5,-5.0]"));
    simpleFigureView2.setP2(DVector.valueOf("[-2.5,5.0]"));
    simpleFigureView2.setP3(DVector.valueOf("[2.5,-5.0]"));
    simpleFigureView2.setP4(DVector.valueOf("[2.5,5.0]"));
    simpleFigureView3.setColor(java.awt.Color.lightGray);
    simpleFigureView3.setDepth(60);
    simpleFigureView3.setFigureType(1);
    simpleFigureView3.setP1(DVector.valueOf("[-2.0,-5.0]"));
    simpleFigureView3.setP2(DVector.valueOf("[-2.0,5.0]"));
    simpleFigureView3.setP3(DVector.valueOf("[2.0,-5.0]"));
    simpleFigureView3.setP4(DVector.valueOf("[2.0,5.0]"));
    simpleFigureView4.setColor(java.awt.Color.lightGray);
    simpleFigureView4.setFigureType(1);
    simpleFigureView4.setP1(DVector.valueOf("[-1.5,-5.0]"));
    simpleFigureView4.setP2(DVector.valueOf("[-1.5,5.0]"));
    simpleFigureView4.setP3(DVector.valueOf("[1.5,-5.0]"));
    simpleFigureView4.setP4(DVector.valueOf("[1.5,5.0]"));
    simpleFigureView5.setColor(java.awt.Color.lightGray);
    simpleFigureView5.setDepth(40);
    simpleFigureView5.setFigureType(1);
    simpleFigureView5.setP1(DVector.valueOf("[-1.0,-5.0]"));
    simpleFigureView5.setP2(DVector.valueOf("[-1.0,5.0]"));
    simpleFigureView5.setP3(DVector.valueOf("[1.0,-5.0]"));
    simpleFigureView5.setP4(DVector.valueOf("[1.0,5.0]"));
    
    jPanel1.setLayout(new java.awt.BorderLayout());
    
    jPanel1.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED)));
    jPanel1.setFont(standardFont);
    jPanel2.setLayout(new java.awt.BorderLayout());
    
    jPanel2.setFont(standardFont);
    layeredScreen1.setCrossCursor(true);
    layeredScreen1.setEqualScales(true);
    layeredScreen1.setMaxX(3.0);
    layeredScreen1.setMinX(-3.0);
    layeredScreen1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        layeredScreen1ValueChanged(evt);
      }
    });
    
    objectPanel1.add(layeredScreen1, java.awt.BorderLayout.CENTER);
    
    jPanel2.add(objectPanel1, java.awt.BorderLayout.CENTER);
    
    vectorTextField1.setBordered(true);
    vectorTextField1.setHorizontal(true);
    vectorTextField1.setPadding(10);
    vectorTextField1.setUnit(new String[] {"cm", "cm"});
    outputPanel1.add(vectorTextField1);
    
    jPanel2.add(outputPanel1, java.awt.BorderLayout.SOUTH);
    
    jPanel1.add(jPanel2, java.awt.BorderLayout.CENTER);
    
    inputPanel1.setLayout(new javax.swing.BoxLayout(inputPanel1, javax.swing.BoxLayout.Y_AXIS));
    
    textSlider1.setDescription("\u03b1 =");
    textSlider1.setModel(new BoundedRealModel(0.0,0.5,1.0));
    textSlider1.setUnit("\u03c0");
    textSlider1.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider1PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider1);
    
    textSlider2.setDescription("n1 =");
    textSlider2.setModel(new BoundedRealModel(1.0,1.5,2.5));
    textSlider2.setPrecision(5);
    textSlider2.setUnit("");
    textSlider2.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider2PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider2);
    
    textSlider3.setDescription("n2 =");
    textSlider3.setModel(new BoundedRealModel(1.0,1.4,2.5));
    textSlider3.setPrecision(5);
    textSlider3.setUnit("");
    textSlider3.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider3PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider3);
    
    textSlider4.setDescription("n3 =");
    textSlider4.setModel(new BoundedRealModel(1.0,1.3,2.5));
    textSlider4.setPrecision(5);
    textSlider4.setUnit("");
    textSlider4.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider4PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider4);
    
    textSlider5.setDescription("n4 =");
    textSlider5.setModel(new BoundedRealModel(1.0,1.2,2.5));
    textSlider5.setPrecision(5);
    textSlider5.setUnit("");
    textSlider5.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider5PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider5);
    
    jPanel1.add(inputPanel1, java.awt.BorderLayout.EAST);
    
    getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
    
  }// </editor-fold>//GEN-END:initComponents
  
  private void simpleFigureView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_simpleFigureView1SourceChanged
    layeredScreen1.addView(simpleFigureView1);
    layeredScreen1.addView(simpleFigureView2);
    layeredScreen1.addView(simpleFigureView3);
    layeredScreen1.addView(simpleFigureView4);
    layeredScreen1.addView(simpleFigureView5);
    layeredScreen1.addView(pointLightSourceView1);
  }//GEN-LAST:event_simpleFigureView1SourceChanged
  
  private void textSlider5PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider5PropertyChange
    double val = textSlider5.getValue();
    singlePlane5.setIndexOfRefractionLeft(val);
    singlePlane6.setIndexOfRefractionRight(val);
    singlePlane7.setIndexOfRefractionRight(val);
    singlePlane8.setIndexOfRefractionLeft(val);
  }//GEN-LAST:event_textSlider5PropertyChange
  
  private void singlePlane8SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_singlePlane8SourceChanged
    opticalBench1.addOpticalElement(singlePlane8);
    layeredScreen1.repaint();
  }//GEN-LAST:event_singlePlane8SourceChanged
  
  private void singlePlane7SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_singlePlane7SourceChanged
    opticalBench1.addOpticalElement(singlePlane7);
    layeredScreen1.repaint();
  }//GEN-LAST:event_singlePlane7SourceChanged
  
  private void textSlider4PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider4PropertyChange
    double val = textSlider4.getValue();
    singlePlane3.setIndexOfRefractionLeft(val);
    singlePlane4.setIndexOfRefractionRight(val);
    singlePlane5.setIndexOfRefractionRight(val);
    singlePlane6.setIndexOfRefractionLeft(val);
  }//GEN-LAST:event_textSlider4PropertyChange
  
  private void singlePlane6SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_singlePlane6SourceChanged
    opticalBench1.addOpticalElement(singlePlane6);
    layeredScreen1.repaint();
  }//GEN-LAST:event_singlePlane6SourceChanged
  
  private void singlePlane5SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_singlePlane5SourceChanged
    opticalBench1.addOpticalElement(singlePlane5);
    layeredScreen1.repaint();
  }//GEN-LAST:event_singlePlane5SourceChanged
  
  private void textSlider3PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider3PropertyChange
    double val = textSlider3.getValue();
    singlePlane1.setIndexOfRefractionLeft(val);
    singlePlane2.setIndexOfRefractionRight(val);
    singlePlane3.setIndexOfRefractionRight(val);
    singlePlane4.setIndexOfRefractionLeft(val);
  }//GEN-LAST:event_textSlider3PropertyChange
  
  private void singlePlane4SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_singlePlane4SourceChanged
    opticalBench1.addOpticalElement(singlePlane4);
    layeredScreen1.repaint();
  }//GEN-LAST:event_singlePlane4SourceChanged
  
  private void singlePlane3SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_singlePlane3SourceChanged
    opticalBench1.addOpticalElement(singlePlane3);
    layeredScreen1.repaint();
  }//GEN-LAST:event_singlePlane3SourceChanged
  
  private void singlePlane2SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_singlePlane2SourceChanged
    opticalBench1.addOpticalElement(singlePlane2);
    layeredScreen1.repaint();
  }//GEN-LAST:event_singlePlane2SourceChanged
  
  private void textSlider2PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider2PropertyChange
    double val = textSlider2.getValue();
    singlePlane1.setIndexOfRefractionRight(val);
    singlePlane2.setIndexOfRefractionLeft(val);
  }//GEN-LAST:event_textSlider2PropertyChange
  
  private void singlePlane1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_singlePlane1SourceChanged
    opticalBench1.addOpticalElement(singlePlane1);
    layeredScreen1.repaint();
  }//GEN-LAST:event_singlePlane1SourceChanged
  
  private void textSlider1PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider1PropertyChange
    pointLightSource1.setMidAngle(textSlider1.getValue()*Math.PI);
  }//GEN-LAST:event_textSlider1PropertyChange
  
  private void pointLightSource1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_pointLightSource1SourceChanged
    opticalBench1.addLightSource(pointLightSource1);
    pointLightSourceView1.setModel(pointLightSource1);
  }//GEN-LAST:event_pointLightSource1SourceChanged
  
  private void layeredScreen1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_layeredScreen1ValueChanged
    vectorTextField1.setValue(layeredScreen1.getClickedPosition());
  }//GEN-LAST:event_layeredScreen1ValueChanged
  
  
// Variables declaration - do not modify//GEN-BEGIN:variables
  protected physbeans.inout.InputPanel inputPanel1;
  protected javax.swing.JPanel jPanel1;
  protected javax.swing.JPanel jPanel2;
  protected physbeans.inout.LayeredScreen layeredScreen1;
  protected physbeans.inout.ObjectPanel objectPanel1;
  protected physbeans.phys.OpticalBench opticalBench1;
  protected physbeans.inout.OutputPanel outputPanel1;
  protected physbeans.phys.PointLightSource pointLightSource1;
  protected physbeans.views.PointLightSourceView pointLightSourceView1;
  protected physbeans.views.SimpleFigureView simpleFigureView1;
  protected physbeans.views.SimpleFigureView simpleFigureView2;
  protected physbeans.views.SimpleFigureView simpleFigureView3;
  protected physbeans.views.SimpleFigureView simpleFigureView4;
  protected physbeans.views.SimpleFigureView simpleFigureView5;
  protected physbeans.phys.SinglePlane singlePlane1;
  protected physbeans.phys.SinglePlane singlePlane2;
  protected physbeans.phys.SinglePlane singlePlane3;
  protected physbeans.phys.SinglePlane singlePlane4;
  protected physbeans.phys.SinglePlane singlePlane5;
  protected physbeans.phys.SinglePlane singlePlane6;
  protected physbeans.phys.SinglePlane singlePlane7;
  protected physbeans.phys.SinglePlane singlePlane8;
  protected physbeans.inout.TextSlider textSlider1;
  protected physbeans.inout.TextSlider textSlider2;
  protected physbeans.inout.TextSlider textSlider3;
  protected physbeans.inout.TextSlider textSlider4;
  protected physbeans.inout.TextSlider textSlider5;
  protected physbeans.inout.VectorTextField vectorTextField1;
// End of variables declaration//GEN-END:variables
  
}
