package physapps.optics;
import javax.swing.*;
import java.awt.*;
import physbeans.inout.*;
import physbeans.model.*;

/**
 * template for simulation applets<br>
 * contains an input, object and output panel in "high" layout.
 */
public class LensCorrection extends PhysBeansApplet {
  
  static public void main(String[] args) {
    startApp(new LensCorrection(), 650, 420);
  }
  
  /** Creates new form Simulation */
  public void init() {
    setLocale();
    initComponents();
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
// <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
  private void initComponents() {
    planeLightSource1 = new physbeans.phys.PlaneLightSource();
    planeLightSourceView1 = new physbeans.views.PlaneLightSourceView();
    lens1 = new physbeans.phys.Lens();
    lensView1 = new physbeans.views.LensView();
    lens2 = new physbeans.phys.Lens();
    lensView2 = new physbeans.views.LensView();
    opticalBench1 = new physbeans.phys.OpticalBench();
    jPanel1 = new javax.swing.JPanel();
    inputPanel1 = new physbeans.inout.InputPanel();
    textSlider3 = new physbeans.inout.TextSlider();
    textSlider4 = new physbeans.inout.TextSlider();
    textSlider5 = new physbeans.inout.TextSlider();
    textSlider1 = new physbeans.inout.TextSlider();
    textSlider6 = new physbeans.inout.TextSlider();
    objectPanel1 = new physbeans.inout.ObjectPanel();
    layeredScreen1 = new physbeans.inout.LayeredScreen();
    outputPanel1 = new physbeans.inout.OutputPanel();
    vectorTextField1 = new physbeans.inout.VectorTextField();
    
    planeLightSource1.setNRays(7);
    planeLightSource1.setPosition(-50.0);
    planeLightSource1.setWidth(4.0);
    planeLightSource1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        planeLightSource1SourceChanged(evt);
      }
    });
    
    planeLightSourceView1.setDepth(40);
    planeLightSourceView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        planeLightSourceView1SourceChanged(evt);
      }
    });
    
    lens1.setIndexOfRefraction(1.5);
    lens1.setMaxHeight(20.0);
    lens1.setRadius2(-1000.0);
    lens1.setThickness(10.0);
    lens1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        lens1SourceChanged(evt);
      }
    });
    
    lensView1.setDepth(60);
    lensView1.setShowPrincipalPlane(false);
    lens2.setMaxHeight(6.0);
    lens2.setRadius2(1000.0);
    lens2.setThickness(2.0);
    lens2.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        lens2SourceChanged(evt);
      }
    });
    
    lensView2.setShowPrincipalPlane(false);
    
    jPanel1.setLayout(new javax.swing.BoxLayout(jPanel1, javax.swing.BoxLayout.Y_AXIS));
    
    jPanel1.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED)));
    jPanel1.setFont(standardFont);
    inputPanel1.setLayout(new java.awt.GridLayout(2, 3));
    
    inputPanel1.setAlignmentX(0.5F);
    textSlider3.setDescription("w =");
    textSlider3.setModel(new BoundedRealModel(2.0,13.0,20.0));
    textSlider3.setUnit("cm");
    textSlider3.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider3PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider3);
    
    textSlider4.setDescription("r =");
    textSlider4.setModel(new BoundedRealModel(0.0,20.0,60.0));
    textSlider4.setUnit("cm");
    textSlider4.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider4PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider4);
    
    textSlider5.setDescription("d =");
    textSlider5.setModel(new BoundedRealModel(2.0,3.0,8.0));
    textSlider5.setUnit("cm");
    textSlider5.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider5PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider5);
    
    textSlider1.setDescription("n1 =");
    textSlider1.setModel(new BoundedRealModel(1.0,1.5,3.0));
    textSlider1.setUnit("");
    textSlider1.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider1PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider1);
    
    textSlider6.setDescription("n2 =");
    textSlider6.setModel(new BoundedRealModel(1.0,1.5,3.0));
    textSlider6.setUnit("");
    textSlider6.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider6PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider6);
    
    jPanel1.add(inputPanel1);
    
    objectPanel1.setPreferredSize(new java.awt.Dimension(200, 250));
    layeredScreen1.setCrossCursor(true);
    layeredScreen1.setEqualScales(true);
    layeredScreen1.setMaxX(30.0);
    layeredScreen1.setMinX(-30.0);
    layeredScreen1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        layeredScreen1ValueChanged(evt);
      }
    });
    
    objectPanel1.add(layeredScreen1, java.awt.BorderLayout.CENTER);
    
    jPanel1.add(objectPanel1);
    
    outputPanel1.setLayout(new java.awt.FlowLayout());
    
    outputPanel1.setPreferredSize(new java.awt.Dimension(50, 30));
    vectorTextField1.setHorizontal(true);
    vectorTextField1.setPadding(30);
    vectorTextField1.setUnit(new String[] {"cm", "cm"});
    outputPanel1.add(vectorTextField1);
    
    jPanel1.add(outputPanel1);
    
    getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
    
  }// </editor-fold>//GEN-END:initComponents
  
  private void planeLightSourceView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_planeLightSourceView1SourceChanged
    layeredScreen1.addView(lensView1);
    layeredScreen1.addView(lensView2);
    layeredScreen1.addView(planeLightSourceView1);
  }//GEN-LAST:event_planeLightSourceView1SourceChanged
  
  private void planeLightSource1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_planeLightSource1SourceChanged
    opticalBench1.addLightSource(planeLightSource1);
    planeLightSourceView1.setModel(planeLightSource1);
  }//GEN-LAST:event_planeLightSource1SourceChanged
  
  private void textSlider6PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider6PropertyChange
    lens2.setIndexOfRefraction(textSlider6.getValue());
    //lens1.trigger();  // lens1 must be triggered once at the beginning
  }//GEN-LAST:event_textSlider6PropertyChange
  
  private void lens2SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_lens2SourceChanged
    opticalBench1.addOpticalElement(lens2);
    lensView2.setModel(lens2);
  }//GEN-LAST:event_lens2SourceChanged
  
  private void lens1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_lens1SourceChanged
    opticalBench1.addOpticalElement(lens1);
    lensView1.setModel(lens1);
  }//GEN-LAST:event_lens1SourceChanged
  
  private void textSlider5PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider5PropertyChange
    lens2.setPosition(textSlider5.getValue());
  }//GEN-LAST:event_textSlider5PropertyChange
  
  private void textSlider1PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider1PropertyChange
    lens1.setIndexOfRefraction(textSlider1.getValue());
  }//GEN-LAST:event_textSlider1PropertyChange
  
  private void textSlider3PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider3PropertyChange
    planeLightSource1.setWidth(textSlider3.getValue());
  }//GEN-LAST:event_textSlider3PropertyChange
  
  private void textSlider4PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider4PropertyChange
    double val = textSlider4.getValue();
    lens2.setRadius1(-val);
    //lens2.setRadius2(val);
  }//GEN-LAST:event_textSlider4PropertyChange
  
  private void layeredScreen1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_layeredScreen1ValueChanged
    vectorTextField1.setValue(layeredScreen1.getClickedPosition());
  }//GEN-LAST:event_layeredScreen1ValueChanged
  
  
// Variables declaration - do not modify//GEN-BEGIN:variables
  protected physbeans.inout.InputPanel inputPanel1;
  protected javax.swing.JPanel jPanel1;
  protected physbeans.inout.LayeredScreen layeredScreen1;
  protected physbeans.phys.Lens lens1;
  protected physbeans.phys.Lens lens2;
  protected physbeans.views.LensView lensView1;
  protected physbeans.views.LensView lensView2;
  protected physbeans.inout.ObjectPanel objectPanel1;
  protected physbeans.phys.OpticalBench opticalBench1;
  protected physbeans.inout.OutputPanel outputPanel1;
  protected physbeans.phys.PlaneLightSource planeLightSource1;
  protected physbeans.views.PlaneLightSourceView planeLightSourceView1;
  protected physbeans.inout.TextSlider textSlider1;
  protected physbeans.inout.TextSlider textSlider3;
  protected physbeans.inout.TextSlider textSlider4;
  protected physbeans.inout.TextSlider textSlider5;
  protected physbeans.inout.TextSlider textSlider6;
  protected physbeans.inout.VectorTextField vectorTextField1;
// End of variables declaration//GEN-END:variables
  
}
