package physapps.optics;
import javax.swing.*;
import java.awt.*;
import physbeans.inout.*;
import physbeans.math.*;
import physbeans.model.*;

/**
 * template for simulation applets<br>
 * contains an input, object and output panel in "high" layout.
 */
public class Telescope extends PhysBeansApplet {
  
  static public void main(String[] args) {
    startApp(new Telescope(), 650, 370);
  }
  
  /** Creates new form Simulation */
  public void init() {
    setLocale();
    initComponents();
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
// <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
  private void initComponents() {
    planeLightSource1 = new physbeans.phys.PlaneLightSource();
    planeLightSourceView1 = new physbeans.views.PlaneLightSourceView();
    lens1 = new physbeans.phys.ThinLens();
    lensView1 = new physbeans.views.LensView();
    lens2 = new physbeans.phys.ThinLens();
    lensView2 = new physbeans.views.LensView();
    opticalBench1 = new physbeans.phys.OpticalBench();
    simpleFigureView1 = new physbeans.views.SimpleFigureView();
    jPanel1 = new javax.swing.JPanel();
    inputPanel1 = new physbeans.inout.InputPanel();
    textSliderAl = new physbeans.inout.TextSlider();
    textSliderF1 = new physbeans.inout.TextSlider();
    textSliderF2 = new physbeans.inout.TextSlider();
    objectPanel1 = new physbeans.inout.ObjectPanel();
    layeredScreen1 = new physbeans.inout.LayeredScreen();
    outputPanel1 = new physbeans.inout.OutputPanel();
    vectorTextField1 = new physbeans.inout.VectorTextField();
    
    planeLightSource1.setNRays(9);
    planeLightSource1.setPosition(-40.0);
    planeLightSource1.setWidth(12.0);
    planeLightSource1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        planeLightSource1SourceChanged(evt);
      }
    });
    
    lens1.setMaxHeight(9.0);
    lens1.setPosition(-20.0);
    lens1.setRadius1(40.0);
    lens1.setRadius2(-40.0);
    lens1.setThickness(2.0);
    lens1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        lens1SourceChanged(evt);
      }
    });
    
    lensView1.setDepth(70);
    lensView1.setFocalPointRadius(0.5);
    lensView1.setShowFocalPoints(true);
    lensView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        lensView1SourceChanged(evt);
      }
    });
    
    lens2.setMaxHeight(9.0);
    lens2.setPosition(1.0);
    lens2.setRadius1(40.0);
    lens2.setRadius2(-40.0);
    lens2.setThickness(2.0);
    lens2.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        lens2SourceChanged(evt);
      }
    });
    
    lensView2.setDepth(60);
    lensView2.setFocalPointRadius(0.5);
    lensView2.setShowFocalPoints(true);
    simpleFigureView1.setDepth(40);
    simpleFigureView1.setFigureType(0);
    simpleFigureView1.setP1(DVector.valueOf("[-30.0,0.0]"));
    simpleFigureView1.setP2(DVector.valueOf("[30.0,0.0]"));
    
    jPanel1.setLayout(new java.awt.BorderLayout());
    
    jPanel1.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED)));
    jPanel1.setFont(standardFont);
    inputPanel1.setLayout(new java.awt.GridLayout(1, 3));
    
    inputPanel1.setAlignmentX(0.5F);
    textSliderAl.setDescription("\u03b1 =");
    textSliderAl.setModel(new BoundedRealModel(-0.3,0.02,0.3));
    textSliderAl.setUnit("\u03c0");
    textSliderAl.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSliderAlPropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSliderAl);
    
    textSliderF1.setDescription("f1 =");
    textSliderF1.setModel(new BoundedRealModel(1.0,32.0,40.0));
    textSliderF1.setUnit("cm");
    textSliderF1.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSliderF1PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSliderF1);
    
    textSliderF2.setDescription("f2 =");
    textSliderF2.setModel(new BoundedRealModel(1.0,8.0,20.0));
    textSliderF2.setUnit("cm");
    textSliderF2.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSliderF2PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSliderF2);
    
    jPanel1.add(inputPanel1, java.awt.BorderLayout.NORTH);
    
    layeredScreen1.setCrossCursor(true);
    layeredScreen1.setEqualScales(true);
    layeredScreen1.setMaxX(30.0);
    layeredScreen1.setMinX(-30.0);
    layeredScreen1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        layeredScreen1ValueChanged(evt);
      }
    });
    
    objectPanel1.add(layeredScreen1, java.awt.BorderLayout.CENTER);
    
    jPanel1.add(objectPanel1, java.awt.BorderLayout.CENTER);
    
    outputPanel1.setLayout(new java.awt.FlowLayout());
    
    vectorTextField1.setHorizontal(true);
    vectorTextField1.setPadding(30);
    vectorTextField1.setUnit(new String[] {"cm", "cm"});
    outputPanel1.add(vectorTextField1);
    
    jPanel1.add(outputPanel1, java.awt.BorderLayout.SOUTH);
    
    getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
    
  }// </editor-fold>//GEN-END:initComponents
  
  private void lensView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_lensView1SourceChanged
    layeredScreen1.addView(lensView1);
    layeredScreen1.addView(lensView2);
    layeredScreen1.addView(planeLightSourceView1);
    layeredScreen1.addView(simpleFigureView1);
  }//GEN-LAST:event_lensView1SourceChanged
  
  private void planeLightSource1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_planeLightSource1SourceChanged
    opticalBench1.addLightSource(planeLightSource1);
    planeLightSourceView1.setModel(planeLightSource1);
  }//GEN-LAST:event_planeLightSource1SourceChanged
  
  private void lens2SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_lens2SourceChanged
    opticalBench1.addOpticalElement(lens2);
    lensView2.setModel(lens2);
  }//GEN-LAST:event_lens2SourceChanged
  
  private void lens1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_lens1SourceChanged
    opticalBench1.addOpticalElement(lens1);
    lensView1.setModel(lens1);
  }//GEN-LAST:event_lens1SourceChanged
  
  private void textSliderAlPropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSliderAlPropertyChange
    double val = textSliderAl.getValue()*Math.PI;
    planeLightSource1.setAngle(val);
    planeLightSource1.setHeight(-20*Math.tan(val));
  }//GEN-LAST:event_textSliderAlPropertyChange
  
  private void textSliderF1PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSliderF1PropertyChange
    double f1 = textSliderF1.getValue();
    lens1.setFocalLength(f1);
    lens2.setPosition(f1 + lens2.getFocalLength() - 20.0);
  }//GEN-LAST:event_textSliderF1PropertyChange
  
  private void textSliderF2PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSliderF2PropertyChange
    double f2 = textSliderF2.getValue();
    lens2.setFocalLength(f2);
    lens2.setPosition(lens1.getFocalLength() + f2 - 20.0);
  }//GEN-LAST:event_textSliderF2PropertyChange
  
  private void layeredScreen1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_layeredScreen1ValueChanged
    vectorTextField1.setValue(layeredScreen1.getClickedPosition());
  }//GEN-LAST:event_layeredScreen1ValueChanged
  
  
// Variables declaration - do not modify//GEN-BEGIN:variables
  protected physbeans.inout.InputPanel inputPanel1;
  protected javax.swing.JPanel jPanel1;
  protected physbeans.inout.LayeredScreen layeredScreen1;
  protected physbeans.phys.ThinLens lens1;
  protected physbeans.phys.ThinLens lens2;
  protected physbeans.views.LensView lensView1;
  protected physbeans.views.LensView lensView2;
  protected physbeans.inout.ObjectPanel objectPanel1;
  protected physbeans.phys.OpticalBench opticalBench1;
  protected physbeans.inout.OutputPanel outputPanel1;
  protected physbeans.phys.PlaneLightSource planeLightSource1;
  protected physbeans.views.PlaneLightSourceView planeLightSourceView1;
  protected physbeans.views.SimpleFigureView simpleFigureView1;
  protected physbeans.inout.TextSlider textSliderAl;
  protected physbeans.inout.TextSlider textSliderF1;
  protected physbeans.inout.TextSlider textSliderF2;
  protected physbeans.inout.VectorTextField vectorTextField1;
// End of variables declaration//GEN-END:variables
  
}
