package physapps.optics;
import javax.swing.*;
import java.awt.*;
import physbeans.inout.*;
import physbeans.model.*;

/**
 * template for simulation applets<br>
 * contains an input, object and output panel in "high" layout.
 */
public class TwoThickLenses extends PhysBeansApplet {
  
  static public void main(String[] args) {
    startApp(new TwoThickLenses(), 650, 420);
  }
  
  /** Creates new form Simulation */
  public void init() {
    setLocale();
    initComponents();
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
// <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
  private void initComponents() {
    planeLightSource1 = new physbeans.phys.PlaneLightSource();
    planeLightSourceView1 = new physbeans.views.PlaneLightSourceView();
    thickLens1 = new physbeans.phys.ThickLens();
    lensView1 = new physbeans.views.LensView();
    thickLens2 = new physbeans.phys.ThickLens();
    lensView2 = new physbeans.views.LensView();
    opticalBench1 = new physbeans.phys.OpticalBench();
    jPanel1 = new javax.swing.JPanel();
    inputPanel1 = new physbeans.inout.InputPanel();
    textSlider5 = new physbeans.inout.TextSlider();
    textSlider4 = new physbeans.inout.TextSlider();
    textSlider6 = new physbeans.inout.TextSlider();
    textSlider1 = new physbeans.inout.TextSlider();
    textSlider3 = new physbeans.inout.TextSlider();
    objectPanel1 = new physbeans.inout.ObjectPanel();
    layeredScreen1 = new physbeans.inout.LayeredScreen();
    outputPanel1 = new physbeans.inout.OutputPanel();
    vectorTextField1 = new physbeans.inout.VectorTextField();
    
    planeLightSource1.setNRays(9);
    planeLightSource1.setPosition(-20.0);
    planeLightSource1.setWidth(8.0);
    planeLightSource1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        planeLightSource1SourceChanged(evt);
      }
    });
    
    planeLightSourceView1.setDepth(40);
    thickLens1.setIndexOfRefraction(1.6);
    thickLens1.setMaxHeight(9.0);
    thickLens1.setThickness(8.0);
    thickLens1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        thickLens1SourceChanged(evt);
      }
    });
    
    lensView1.setDepth(60);
    lensView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        lensView1SourceChanged(evt);
      }
    });
    
    thickLens2.setIndexOfRefraction(1.6);
    thickLens2.setMaxHeight(9.0);
    thickLens2.setThickness(8.0);
    thickLens2.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        thickLens2SourceChanged(evt);
      }
    });
    
    
    jPanel1.setLayout(new javax.swing.BoxLayout(jPanel1, javax.swing.BoxLayout.Y_AXIS));
    
    jPanel1.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED)));
    jPanel1.setFont(standardFont);
    inputPanel1.setLayout(new java.awt.GridLayout(2, 3));
    
    inputPanel1.setAlignmentX(0.5F);
    textSlider5.setDescription("\u03b1 =");
    textSlider5.setModel(new BoundedRealModel(-0.3,0.0,0.3));
    textSlider5.setUnit("\u03c0");
    textSlider5.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider5PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider5);
    
    textSlider4.setDescription("r1 =");
    textSlider4.setModel(new BoundedRealModel(-60.0,20.0,60.0));
    textSlider4.setUnit("cm");
    textSlider4.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider4PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider4);
    
    textSlider6.setDescription("d =");
    textSlider6.setModel(new BoundedRealModel(5.0,10.0,20.0));
    textSlider6.setUnit("cm");
    textSlider6.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider6PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider6);
    
    textSlider1.setDescription("y =");
    textSlider1.setModel(new BoundedRealModel(-10.0,0.0,10.0));
    textSlider1.setUnit("cm");
    textSlider1.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider1PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider1);
    
    textSlider3.setDescription("r2 =");
    textSlider3.setModel(new BoundedRealModel(-60.0,20.0,60.0));
    textSlider3.setUnit("cm");
    textSlider3.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider3PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider3);
    
    jPanel1.add(inputPanel1);
    
    objectPanel1.setPreferredSize(new java.awt.Dimension(200, 250));
    layeredScreen1.setCrossCursor(true);
    layeredScreen1.setEqualScales(true);
    layeredScreen1.setMaxX(50.0);
    layeredScreen1.setMinX(-15.0);
    layeredScreen1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        layeredScreen1ValueChanged(evt);
      }
    });
    
    objectPanel1.add(layeredScreen1, java.awt.BorderLayout.CENTER);
    
    jPanel1.add(objectPanel1);
    
    outputPanel1.setLayout(new java.awt.FlowLayout());
    
    outputPanel1.setPreferredSize(new java.awt.Dimension(50, 30));
    vectorTextField1.setHorizontal(true);
    vectorTextField1.setPadding(30);
    vectorTextField1.setUnit(new String[] {"cm", "cm"});
    outputPanel1.add(vectorTextField1);
    
    jPanel1.add(outputPanel1);
    
    getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
    
  }// </editor-fold>//GEN-END:initComponents
  
  private void lensView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_lensView1SourceChanged
    layeredScreen1.addView(lensView1);
    layeredScreen1.addView(lensView2);
    layeredScreen1.addView(planeLightSourceView1);
  }//GEN-LAST:event_lensView1SourceChanged
  
  private void thickLens2SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_thickLens2SourceChanged
    opticalBench1.addOpticalElement(thickLens2);
    lensView2.setModel(thickLens2);
  }//GEN-LAST:event_thickLens2SourceChanged
  
  private void thickLens1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_thickLens1SourceChanged
    opticalBench1.addOpticalElement(thickLens1);
    lensView1.setModel(thickLens1);
  }//GEN-LAST:event_thickLens1SourceChanged
  
  private void textSlider1PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider1PropertyChange
    planeLightSource1.setHeight(textSlider1.getValue());
  }//GEN-LAST:event_textSlider1PropertyChange
  
  private void planeLightSource1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_planeLightSource1SourceChanged
    opticalBench1.addLightSource(planeLightSource1);
    planeLightSourceView1.setModel(planeLightSource1);
  }//GEN-LAST:event_planeLightSource1SourceChanged
  
  private void textSlider6PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider6PropertyChange
    thickLens2.setPosition(textSlider6.getValue());
  }//GEN-LAST:event_textSlider6PropertyChange
  
  private void textSlider5PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider5PropertyChange
    planeLightSource1.setAngle(textSlider5.getValue()*Math.PI);
  }//GEN-LAST:event_textSlider5PropertyChange
  
  private void textSlider4PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider4PropertyChange
    double val = textSlider4.getValue();
    thickLens1.setRadius1(val);
    thickLens1.setRadius2(-val);
  }//GEN-LAST:event_textSlider4PropertyChange
  
  private void textSlider3PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider3PropertyChange
    double val = textSlider3.getValue();
    thickLens2.setRadius1(val);
    thickLens2.setRadius2(-val);
  }//GEN-LAST:event_textSlider3PropertyChange
  
  private void layeredScreen1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_layeredScreen1ValueChanged
    vectorTextField1.setValue(layeredScreen1.getClickedPosition());
  }//GEN-LAST:event_layeredScreen1ValueChanged
  
  
// Variables declaration - do not modify//GEN-BEGIN:variables
  protected physbeans.inout.InputPanel inputPanel1;
  protected javax.swing.JPanel jPanel1;
  protected physbeans.inout.LayeredScreen layeredScreen1;
  protected physbeans.views.LensView lensView1;
  protected physbeans.views.LensView lensView2;
  protected physbeans.inout.ObjectPanel objectPanel1;
  protected physbeans.phys.OpticalBench opticalBench1;
  protected physbeans.inout.OutputPanel outputPanel1;
  protected physbeans.phys.PlaneLightSource planeLightSource1;
  protected physbeans.views.PlaneLightSourceView planeLightSourceView1;
  protected physbeans.inout.TextSlider textSlider1;
  protected physbeans.inout.TextSlider textSlider3;
  protected physbeans.inout.TextSlider textSlider4;
  protected physbeans.inout.TextSlider textSlider5;
  protected physbeans.inout.TextSlider textSlider6;
  protected physbeans.phys.ThickLens thickLens1;
  protected physbeans.phys.ThickLens thickLens2;
  protected physbeans.inout.VectorTextField vectorTextField1;
// End of variables declaration//GEN-END:variables
  
}
