package physapps.quantummechanics;

import physbeans.inout.*;
import physbeans.math.*;
import physbeans.model.*;

/**
 * template for simulation applets<br>
 * contains an input, object and output panel
 */
public class CoulombEigenfunctions extends PhysBeansApplet {

  static public void main(String[] args) {
    startApp(new CoulombEigenfunctions(), 590, 640);
  }

  /** Creates new form Simulation */
  public void init() {
    setLocale();
    initComponents();
  }

  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    schroedinger2D1 = new physbeans.phys.Schroedinger2D();
    coulomb2DPotential1 = new physbeans.phys.Coulomb2DPotential();
    coulomb2DEigenfunction1 = new physbeans.phys.Coulomb2DEigenfunction();
    jetColorTable1 = new physbeans.views.JetColorTable();
    complexGridView1 = new physbeans.views.ComplexGridView();
    simpleFigureView1 = new physbeans.views.SimpleFigureView();
    complexToRealFunctionAdapter1 = new physbeans.func.ComplexToRealFunctionAdapter();
    obliqueCutFunction1 = new physbeans.func.ObliqueCutFunction();
    functionView1 = new physbeans.views.FunctionView();
    jPanel1 = new javax.swing.JPanel();
    jPanel2 = new javax.swing.JPanel();
    objectPanel = new physbeans.inout.PhysicsPanel();
    layeredScreen1 = new physbeans.inout.LayeredScreen();
    outputPanel = new physbeans.inout.PhysicsPanel();
    controlledLayeredScreen1 = new physbeans.inout.ControlledLayeredScreen();
    inputPanel = new physbeans.inout.PhysicsPanel();
    timer1 = new physbeans.inout.Timer();
    textSlider2 = new physbeans.inout.TextSlider();
    radioButtonBoxN = new physbeans.inout.RadioButtonBox();
    radioButtonBoxM = new physbeans.inout.RadioButtonBox();
    radioButtonBox1 = new physbeans.inout.RadioButtonBox();
    switchBox1 = new physbeans.inout.SwitchBox();
    textSlider1 = new physbeans.inout.TextSlider();

    schroedinger2D1.setXMax(7.0E-9);
    schroedinger2D1.setXMin(-7.0E-9);
    schroedinger2D1.setYMax(7.0E-9);
    schroedinger2D1.setYMin(-7.0E-9);
    schroedinger2D1.setBoundaryWidthX(2);
    schroedinger2D1.setBoundaryWidthY(2);
    schroedinger2D1.setGridSizeX(154);
    schroedinger2D1.setInitFunction(coulomb2DEigenfunction1);
    schroedinger2D1.setPotential(coulomb2DPotential1);
    schroedinger2D1.setTimeIncrement(1.0E-16);
    schroedinger2D1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        schroedinger2D1SourceChanged(evt);
      }
    });

    coulomb2DEigenfunction1.setNEnergyLevels(8);
    coulomb2DEigenfunction1.setSimpleEigenfunction(IVector.valueOf("[8,5]"));

    complexGridView1.setColors(jetColorTable1);
    complexGridView1.setDepth(60);
    complexGridView1.setMaxVal(2.0E8);
    complexGridView1.setMinVal(-2.0E8);
    complexGridView1.setType(ComplexToRealEnum.ABS2);
    complexGridView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        complexGridView1SourceChanged(evt);
      }
    });

    simpleFigureView1.setFigureType(0);
    simpleFigureView1.setP1(DVector.valueOf("[-7.0E-9,0.0]"));
    simpleFigureView1.setP2(DVector.valueOf("[7.0E-9,0.0]"));
    simpleFigureView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        simpleFigureView1SourceChanged(evt);
      }
    });

    complexToRealFunctionAdapter1.setYMax(2.0E8);
    complexToRealFunctionAdapter1.setYMin(-2.0E8);
    complexToRealFunctionAdapter1.setConversionType(ComplexToRealEnum.ABS);
    complexToRealFunctionAdapter1.setCutoff(1.0E7);
    complexToRealFunctionAdapter1.setScreen(controlledLayeredScreen1);
    complexToRealFunctionAdapter1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        complexToRealFunctionAdapter1ValueChanged(evt);
      }
    });

    obliqueCutFunction1.setNPoints(200);
    obliqueCutFunction1.setAlpha(0.0);
    obliqueCutFunction1.setLength(1.6E-8);
    obliqueCutFunction1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        obliqueCutFunction1ValueChanged(evt);
      }
    });

    functionView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        functionView1SourceChanged(evt);
      }
    });

    jPanel1.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED)));
    jPanel1.setFont(standardFont);
    jPanel1.setLayout(new java.awt.BorderLayout());

    jPanel2.setFont(standardFont);
    jPanel2.setLayout(new javax.swing.BoxLayout(jPanel2, javax.swing.BoxLayout.Y_AXIS));

    objectPanel.setBackground(new java.awt.Color(255, 255, 175));
    objectPanel.setBorder(javax.swing.BorderFactory.createEmptyBorder(3, 3, 3, 3));
    objectPanel.setFont(standardFont);
    objectPanel.setOpaque(true);
    objectPanel.setPreferredSize(new java.awt.Dimension(106, 300));
    objectPanel.setLayout(new java.awt.BorderLayout());

    layeredScreen1.setMaxX(7.0E-9);
    layeredScreen1.setMaxY(7.0E-9);
    layeredScreen1.setMinX(-7.0E-9);
    layeredScreen1.setMinY(-7.0E-9);
    layeredScreen1.setViewActive(new boolean[] {true, true});
    objectPanel.add(layeredScreen1, java.awt.BorderLayout.CENTER);

    jPanel2.add(objectPanel);

    outputPanel.setBackground(new java.awt.Color(150, 200, 255));
    outputPanel.setBorder(javax.swing.BorderFactory.createEtchedBorder());
    outputPanel.setFont(standardFont);
    outputPanel.setOpaque(true);
    outputPanel.setPreferredSize(new java.awt.Dimension(316, 200));
    outputPanel.setLayout(new javax.swing.BoxLayout(outputPanel, javax.swing.BoxLayout.LINE_AXIS));

    controlledLayeredScreen1.setBordered(true);
    controlledLayeredScreen1.setMaxX(6.9E-9);
    controlledLayeredScreen1.setMinX(-6.9E-9);
    java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("physapps.quantummechanics.CoulombEigenfunctions", currentLocale); // NOI18N
    controlledLayeredScreen1.setPositionLabel(bundle.getString("osciPosition")); // NOI18N
    controlledLayeredScreen1.setScaleLabel(bundle.getString("osciScale")); // NOI18N
    controlledLayeredScreen1.setViewActive(new boolean[] {true, true});
    outputPanel.add(controlledLayeredScreen1);

    jPanel2.add(outputPanel);

    jPanel1.add(jPanel2, java.awt.BorderLayout.CENTER);

    inputPanel.setBackground(new java.awt.Color(100, 255, 255));
    inputPanel.setBorder(javax.swing.BorderFactory.createEtchedBorder());
    inputPanel.setFont(standardFont);
    inputPanel.setOpaque(true);
    inputPanel.setPreferredSize(new java.awt.Dimension(217, 200));
    inputPanel.setLayout(new javax.swing.BoxLayout(inputPanel, javax.swing.BoxLayout.Y_AXIS));

    timer1.setDelay(30L);
    timer1.setExplanation(bundle.getString("timerLabel")); // NOI18N
    timer1.addTimerListener(new physbeans.event.TimerListener() {
      public void nextStep(physbeans.event.NextStepEvent evt) {
        timer1NextStep(evt);
      }
      public void restart(physbeans.event.RestartEvent evt) {
        timer1Restart(evt);
      }
    });
    inputPanel.add(timer1);

    textSlider2.setDescription("Z =");
    textSlider2.setLogarithmic(true);
    textSlider2.setModel(new BoundedRealModel(0.01,1.0,100.0));
    textSlider2.setUnit("");
    textSlider2.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider2PropertyChange(evt);
      }
    });
    inputPanel.add(textSlider2);

    radioButtonBoxN.setBoxLabel(new String[] {"1", "2", "3", "4", "5", "6", "7", "8"});
    radioButtonBoxN.setSelected(7);
    radioButtonBoxN.setTitle(bundle.getString("eigenN")); // NOI18N
    radioButtonBoxN.setWithTwoColumns(true);
    radioButtonBoxN.addSwitchListener(new physbeans.event.SwitchListener() {
      public void valueChanged(physbeans.event.SwitchEvent evt) {
        radioButtonBoxNValueChanged(evt);
      }
    });
    inputPanel.add(radioButtonBoxN);

    radioButtonBoxM.setBoxLabel(new String[] {"0", "1", "2", "3", "4", "5", "6", "7"});
    radioButtonBoxM.setSelected(5);
    radioButtonBoxM.setTitle(bundle.getString("eigenM")); // NOI18N
    radioButtonBoxM.setWithTwoColumns(true);
    radioButtonBoxM.addSwitchListener(new physbeans.event.SwitchListener() {
      public void valueChanged(physbeans.event.SwitchEvent evt) {
        radioButtonBoxMValueChanged(evt);
      }
    });
    inputPanel.add(radioButtonBoxM);

    radioButtonBox1.setBoxLabel( new String[] {
      bundle.getString("real"), bundle.getString("imag"), bundle.getString("abs"),
      bundle.getString("abs2"), bundle.getString("phase")
    }
  );
  radioButtonBox1.setSelected(3);
  radioButtonBox1.setTitle(bundle.getString("Display")); // NOI18N
  radioButtonBox1.addSwitchListener(new physbeans.event.SwitchListener() {
    public void valueChanged(physbeans.event.SwitchEvent evt) {
      radioButtonBox1ValueChanged(evt);
    }
  });
  inputPanel.add(radioButtonBox1);

  switchBox1.setBoxLabel( new String[] {bundle.getString("s1")});
  switchBox1.setSelected(new boolean[] {true});
  switchBox1.setTitle("");
  switchBox1.addSwitchListener(new physbeans.event.SwitchListener() {
    public void valueChanged(physbeans.event.SwitchEvent evt) {
      switchBox1ValueChanged(evt);
    }
  });
  inputPanel.add(switchBox1);

  textSlider1.setDescription("\u03b1 =");
  textSlider1.setModel(new BoundedRealModel(-0.5,0.0,0.5));
  textSlider1.setUnit("* \u03c0");
  textSlider1.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
    public void propertyChange(java.beans.PropertyChangeEvent evt) {
      textSlider1PropertyChange(evt);
    }
  });
  inputPanel.add(textSlider1);

  jPanel1.add(inputPanel, java.awt.BorderLayout.EAST);

  getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
  }// </editor-fold>//GEN-END:initComponents

  private void timer1NextStep(physbeans.event.NextStepEvent evt) {//GEN-FIRST:event_timer1NextStep
    schroedinger2D1.nextStep();
  }//GEN-LAST:event_timer1NextStep

  private void timer1Restart(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart
    schroedinger2D1.restart();
  }//GEN-LAST:event_timer1Restart

  private void schroedinger2D1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_schroedinger2D1SourceChanged
    complexGridView1.setModel(schroedinger2D1);
    complexToRealFunctionAdapter1.setComplexFunction(schroedinger2D1);
  }//GEN-LAST:event_schroedinger2D1SourceChanged

  private void functionView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_functionView1SourceChanged
    controlledLayeredScreen1.addView(functionView1);
  }//GEN-LAST:event_functionView1SourceChanged

  private void complexGridView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_complexGridView1SourceChanged
    layeredScreen1.addView(complexGridView1);
  }//GEN-LAST:event_complexGridView1SourceChanged

  private void complexToRealFunctionAdapter1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_complexToRealFunctionAdapter1ValueChanged
    obliqueCutFunction1.setScalarField(complexToRealFunctionAdapter1);
  }//GEN-LAST:event_complexToRealFunctionAdapter1ValueChanged

  private void radioButtonBox1ValueChanged(physbeans.event.SwitchEvent evt) {//GEN-FIRST:event_radioButtonBox1ValueChanged
    complexToRealFunctionAdapter1.setConversionTypeFromInt(radioButtonBox1.getSelected());
    complexGridView1.setTypeFromInt(radioButtonBox1.getSelected());
}//GEN-LAST:event_radioButtonBox1ValueChanged

  private void simpleFigureView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_simpleFigureView1SourceChanged
    layeredScreen1.addView(simpleFigureView1);
  }//GEN-LAST:event_simpleFigureView1SourceChanged

  private void textSlider1PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider1PropertyChange
    double val = textSlider1.getValue() * Math.PI;
    obliqueCutFunction1.setAlpha(val);
    simpleFigureView1.setAngle(val);
  }//GEN-LAST:event_textSlider1PropertyChange

  private void switchBox1ValueChanged(physbeans.event.SwitchEvent evt) {//GEN-FIRST:event_switchBox1ValueChanged
    layeredScreen1.setViewActive(1, switchBox1.getSelected(0));
  }//GEN-LAST:event_switchBox1ValueChanged

  private void radioButtonBoxNValueChanged(physbeans.event.SwitchEvent evt) {//GEN-FIRST:event_radioButtonBoxNValueChanged
    coulomb2DEigenfunction1.setSimpleEigenfunction(radioButtonBoxN.getSelected()+1,
                                                   radioButtonBoxM.getSelected());
  }//GEN-LAST:event_radioButtonBoxNValueChanged

  private void radioButtonBoxMValueChanged(physbeans.event.SwitchEvent evt) {//GEN-FIRST:event_radioButtonBoxMValueChanged
    coulomb2DEigenfunction1.setSimpleEigenfunction(radioButtonBoxN.getSelected()+1,
                                                   radioButtonBoxM.getSelected());
  }//GEN-LAST:event_radioButtonBoxMValueChanged

  private void obliqueCutFunction1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_obliqueCutFunction1ValueChanged
    functionView1.setModel(obliqueCutFunction1.getXVector(), obliqueCutFunction1.getYVector());
  }//GEN-LAST:event_obliqueCutFunction1ValueChanged

  private void textSlider2PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider2PropertyChange
   coulomb2DEigenfunction1.setZ(textSlider2.getValue());
  }//GEN-LAST:event_textSlider2PropertyChange

  // Variables declaration - do not modify//GEN-BEGIN:variables
  protected physbeans.views.ComplexGridView complexGridView1;
  protected physbeans.func.ComplexToRealFunctionAdapter complexToRealFunctionAdapter1;
  protected physbeans.inout.ControlledLayeredScreen controlledLayeredScreen1;
  protected physbeans.phys.Coulomb2DEigenfunction coulomb2DEigenfunction1;
  protected physbeans.phys.Coulomb2DPotential coulomb2DPotential1;
  protected physbeans.views.FunctionView functionView1;
  protected physbeans.inout.PhysicsPanel inputPanel;
  protected javax.swing.JPanel jPanel1;
  protected javax.swing.JPanel jPanel2;
  protected physbeans.views.JetColorTable jetColorTable1;
  protected physbeans.inout.LayeredScreen layeredScreen1;
  protected physbeans.inout.PhysicsPanel objectPanel;
  protected physbeans.func.ObliqueCutFunction obliqueCutFunction1;
  protected physbeans.inout.PhysicsPanel outputPanel;
  protected physbeans.inout.RadioButtonBox radioButtonBox1;
  protected physbeans.inout.RadioButtonBox radioButtonBoxM;
  protected physbeans.inout.RadioButtonBox radioButtonBoxN;
  protected physbeans.phys.Schroedinger2D schroedinger2D1;
  protected physbeans.views.SimpleFigureView simpleFigureView1;
  protected physbeans.inout.SwitchBox switchBox1;
  protected physbeans.inout.TextSlider textSlider1;
  protected physbeans.inout.TextSlider textSlider2;
  protected physbeans.inout.Timer timer1;
  // End of variables declaration//GEN-END:variables
}
