package physapps.thermodynamics;

import javax.swing.*;
import java.awt.*;
import physbeans.inout.*;
import physbeans.model.*;
import physbeans.phys.*;
import physbeans.math.*;

/**
 * template for simulation applets<br>
 * contains an input, object and output panel
 */
public class JouleCycle extends PhysBeansApplet {
  
  static public void main(String[] args) {
    startApp(new JouleCycle(), 560, 470);
  }
  
  /** Creates new form Simulation */
  public void init() {
    setLocale();
    initComponents();
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
// <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
  private void initComponents() {
    cyclicProcess1 = new physbeans.phys.CyclicProcess();
    perfectGas1 = new physbeans.phys.PerfectGas();
    arithmeticFunction1 = new physbeans.func.ArithmeticFunction();
    arithmeticFunction2 = new physbeans.func.ArithmeticFunction();
    multiplexer1 = new physbeans.func.Multiplexer();
    multiplexer2 = new physbeans.func.Multiplexer();
    multiplexer3 = new physbeans.func.Multiplexer();
    turbineView1 = new physbeans.views.TurbineView();
    jPanel1 = new javax.swing.JPanel();
    jPanel2 = new javax.swing.JPanel();
    objectPanel1 = new physbeans.inout.ObjectPanel();
    layeredScreen1 = new physbeans.inout.LayeredScreen();
    numericTextField1 = new physbeans.inout.NumericTextField();
    outputPanel1 = new physbeans.inout.OutputPanel();
    xYScope1 = new physbeans.inout.XYScope();
    inputPanel1 = new physbeans.inout.InputPanel();
    timer1 = new physbeans.inout.Timer();
    textSlider1 = new physbeans.inout.TextSlider();
    textSlider2 = new physbeans.inout.TextSlider();
    textSlider3 = new physbeans.inout.TextSlider();
    textSlider4 = new physbeans.inout.TextSlider();
    
    cyclicProcess1.setNSteps(new int[]{50,100,50,100});
    cyclicProcess1.setPoints(DVector.valueOf("[0.8702,0.3729,0.4418]"));
    cyclicProcess1.setPolytropicExponents(DVector.valueOf("[1.4,0.0,1.4,0.0]"));
    cyclicProcess1.setStartPressure(100000.0);
    cyclicProcess1.setSystem(perfectGas1);
    cyclicProcess1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        cyclicProcess1SourceChanged(evt);
      }
    });
    
    perfectGas1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        perfectGas1SourceChanged(evt);
        perfectGas1SourceChanged1(evt);
        perfectGas1SourceChanged2(evt);
      }
    });
    
    arithmeticFunction1.setAssociativity(4);
    arithmeticFunction1.setFirstOp(3);
    arithmeticFunction1.setFourthArg(1.4);
    arithmeticFunction1.setSecondOp(5);
    arithmeticFunction1.setThirdArg(1.0);
    arithmeticFunction1.setThirdOp(3);
    arithmeticFunction1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        arithmeticFunction1ValueChanged(evt);
      }
    });
    
    arithmeticFunction2.setAssociativity(1);
    arithmeticFunction2.setFirstOp(2);
    arithmeticFunction2.setSecondArg(287.2);
    arithmeticFunction2.setSecondOp(3);
    arithmeticFunction2.setThirdOp(2);
    arithmeticFunction2.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        arithmeticFunction2ValueChanged(evt);
      }
    });
    
    multiplexer1.setInputLength(3);
    multiplexer1.setCollectInput(false);
    multiplexer1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        multiplexer1ValueChanged(evt);
      }
    });
    
    multiplexer2.setAutoTriggered(false);
    multiplexer2.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        multiplexer2ValueChanged(evt);
      }
    });
    
    multiplexer3.setCollectInput(false);
    multiplexer3.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        multiplexer3ValueChanged(evt);
      }
    });
    
    turbineView1.setTMax(1100.0);
    turbineView1.setTMin(300.0);
    turbineView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        turbineView1SourceChanged(evt);
      }
    });
    
    
    jPanel1.setLayout(new java.awt.BorderLayout());
    
    jPanel1.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED)));
    jPanel1.setFont(standardFont);
    jPanel2.setLayout(new javax.swing.BoxLayout(jPanel2, javax.swing.BoxLayout.Y_AXIS));
    
    jPanel2.setFont(standardFont);
    layeredScreen1.setBordered(true);
    layeredScreen1.setEqualScales(true);
    layeredScreen1.setMaxX(2.2);
    layeredScreen1.setMinX(-2.2);
    layeredScreen1.setBackground(new java.awt.Color(255, 255, 255));
    layeredScreen1.setOpaque(true);
    objectPanel1.add(layeredScreen1, java.awt.BorderLayout.CENTER);
    
    numericTextField1.setDescription("T =");
    numericTextField1.setEditable(false);
    numericTextField1.setPrecision(4);
    numericTextField1.setUnit("K");
    objectPanel1.add(numericTextField1, java.awt.BorderLayout.SOUTH);
    
    jPanel2.add(objectPanel1);
    
    xYScope1.setBufferSize(5000);
    xYScope1.setDotSize(6);
    xYScope1.setMaxX(1.7);
    xYScope1.setMaxY(800000.0);
    xYScope1.setMinX(0.0);
    xYScope1.setMinY(0.0);
    xYScope1.setPositionLabel(java.util.ResourceBundle.getBundle("physapps.thermodynamics.JouleCycle", currentLocale).getString("osciPosition"));
    xYScope1.setScaleLabel(java.util.ResourceBundle.getBundle("physapps.thermodynamics.JouleCycle", currentLocale).getString("osciScale"));
    xYScope1.setShowMarker(true);
    outputPanel1.add(xYScope1);
    
    jPanel2.add(outputPanel1);
    
    jPanel1.add(jPanel2, java.awt.BorderLayout.CENTER);
    
    inputPanel1.setLayout(new javax.swing.BoxLayout(inputPanel1, javax.swing.BoxLayout.Y_AXIS));
    
    timer1.setDelay(40L);
    timer1.setExplanation(java.util.ResourceBundle.getBundle("physapps.thermodynamics.JouleCycle", currentLocale).getString("timerLabel"));
    timer1.addTimerListener(new physbeans.event.TimerListener() {
      public void nextStep(physbeans.event.NextStepEvent evt) {
        timer1NextStep(evt);
      }
      public void restart(physbeans.event.RestartEvent evt) {
        timer1Restart(evt);
        timer1Restart1(evt);
      }
    });
    
    inputPanel1.add(timer1);
    
    textSlider1.setDescription("p1 =");
    textSlider1.setModel(new BoundedRealModel(50000.0,100000.0,600000.0));
    textSlider1.setUnit("Pa");
    textSlider1.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider1PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider1);
    
    textSlider2.setDescription("V1 =");
    textSlider2.setModel(new BoundedRealModel(0.5,0.8702,1.5));
    textSlider2.setUnit("m\u00b3");
    textSlider2.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider2PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider2);
    
    textSlider3.setDescription("\u03b5 =");
    textSlider3.setModel(new BoundedRealModel(1.0,6.0,12.0));
    textSlider3.setUnit("");
    textSlider3.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider3PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider3);
    
    textSlider4.setDescription("T3 =");
    textSlider4.setModel(new BoundedRealModel(300.0,923.0,1500.0));
    textSlider4.setUnit("K");
    textSlider4.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider4PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider4);
    
    jPanel1.add(inputPanel1, java.awt.BorderLayout.EAST);
    
    getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
    
  }// </editor-fold>//GEN-END:initComponents

  private void turbineView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_turbineView1SourceChanged
    layeredScreen1.addView(turbineView1);
  }//GEN-LAST:event_turbineView1SourceChanged

  private void cyclicProcess1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_cyclicProcess1SourceChanged
    multiplexer3.setInputValues(1, cyclicProcess1.getPhase());
  }//GEN-LAST:event_cyclicProcess1SourceChanged
  
  private void arithmeticFunction2ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_arithmeticFunction2ValueChanged
    multiplexer1.setInputValues(2, arithmeticFunction2.getResult());
  }//GEN-LAST:event_arithmeticFunction2ValueChanged
  
  private void textSlider4PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider4PropertyChange
    arithmeticFunction2.setFirstArg(textSlider4.getValue());
  }//GEN-LAST:event_textSlider4PropertyChange
  
  private void arithmeticFunction1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_arithmeticFunction1ValueChanged
    multiplexer1.setInputValues(1, arithmeticFunction1.getResult());
  }//GEN-LAST:event_arithmeticFunction1ValueChanged
  
  private void textSlider3PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider3PropertyChange
    double val = textSlider3.getValue();
    arithmeticFunction1.setSecondArg(val);
    arithmeticFunction2.setFourthArg(val);
  }//GEN-LAST:event_textSlider3PropertyChange
  
  private void multiplexer3ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_multiplexer3ValueChanged
    turbineView1.setModel(multiplexer3.getOutputVector());
  }//GEN-LAST:event_multiplexer3ValueChanged
  
  private void perfectGas1SourceChanged2(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_perfectGas1SourceChanged2
    numericTextField1.setValue(perfectGas1.getTemperature());
  }//GEN-LAST:event_perfectGas1SourceChanged2
  
  private void perfectGas1SourceChanged1(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_perfectGas1SourceChanged1
    multiplexer3.setInputValues(0, perfectGas1.getTemperature());
  }//GEN-LAST:event_perfectGas1SourceChanged1
  
  private void multiplexer2ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_multiplexer2ValueChanged
    xYScope1.setInputVector(multiplexer2.getOutputVector());
  }//GEN-LAST:event_multiplexer2ValueChanged
  
  private void perfectGas1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_perfectGas1SourceChanged
    multiplexer2.setInputValues(0, perfectGas1.getVolume());
    multiplexer2.setInputValues(1, perfectGas1.getPressure());
  }//GEN-LAST:event_perfectGas1SourceChanged
  
  private void multiplexer1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_multiplexer1ValueChanged
    cyclicProcess1.setPoints(multiplexer1.getOutputVector());
  }//GEN-LAST:event_multiplexer1ValueChanged
  
  private void textSlider2PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider2PropertyChange
    double val = textSlider2.getValue();
    multiplexer1.setInputValues(0, val);
    arithmeticFunction1.setFirstArg(val);
  }//GEN-LAST:event_textSlider2PropertyChange
  
  private void textSlider1PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider1PropertyChange
    double val = textSlider1.getValue();
    cyclicProcess1.setStartPressure(val);
    arithmeticFunction2.setThirdArg(val);
  }//GEN-LAST:event_textSlider1PropertyChange
  
  private void timer1Restart1(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart1
    xYScope1.restart();
  }//GEN-LAST:event_timer1Restart1
  
  private void timer1Restart(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart
    cyclicProcess1.restart();
  }//GEN-LAST:event_timer1Restart
  
  private void timer1NextStep(physbeans.event.NextStepEvent evt) {//GEN-FIRST:event_timer1NextStep
    cyclicProcess1.nextStep();
    multiplexer2.trigger();
  }//GEN-LAST:event_timer1NextStep
  
  
// Variables declaration - do not modify//GEN-BEGIN:variables
  protected physbeans.func.ArithmeticFunction arithmeticFunction1;
  protected physbeans.func.ArithmeticFunction arithmeticFunction2;
  protected physbeans.phys.CyclicProcess cyclicProcess1;
  protected physbeans.inout.InputPanel inputPanel1;
  protected javax.swing.JPanel jPanel1;
  protected javax.swing.JPanel jPanel2;
  protected physbeans.inout.LayeredScreen layeredScreen1;
  protected physbeans.func.Multiplexer multiplexer1;
  protected physbeans.func.Multiplexer multiplexer2;
  protected physbeans.func.Multiplexer multiplexer3;
  protected physbeans.inout.NumericTextField numericTextField1;
  protected physbeans.inout.ObjectPanel objectPanel1;
  protected physbeans.inout.OutputPanel outputPanel1;
  protected physbeans.phys.PerfectGas perfectGas1;
  protected physbeans.inout.TextSlider textSlider1;
  protected physbeans.inout.TextSlider textSlider2;
  protected physbeans.inout.TextSlider textSlider3;
  protected physbeans.inout.TextSlider textSlider4;
  protected physbeans.inout.Timer timer1;
  protected physbeans.views.TurbineView turbineView1;
  protected physbeans.inout.XYScope xYScope1;
// End of variables declaration//GEN-END:variables
  
}
