package physapps.waves;
import physbeans.inout.*;
import physbeans.model.*;
import physbeans.math.*;

/**
 * template for simulation applets<br>
 * contains an input, object and output panel
 */
public class PerpendicularPlaneWaves extends PhysBeansApplet {
  
  static public void main(String[] args) {
    startApp(new PerpendicularPlaneWaves(), 535, 500);
  }
  
  /** Creates new form Simulation */
  public void init() {
    setLocale();
    initComponents();
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    rippleTank1 = new physbeans.phys.RippleTank();
    lineWaveSource1 = new physbeans.phys.LineWaveSource();
    lineWaveSource2 = new physbeans.phys.LineWaveSource();
    gridView1 = new physbeans.views.GridView();
    simpleFigureView1 = new physbeans.views.SimpleFigureView();
    pointDetector1 = new physbeans.func.PointDetector();
    jPanel1 = new javax.swing.JPanel();
    jPanel2 = new javax.swing.JPanel();
    objectPanel1 = new physbeans.inout.ObjectPanel();
    layeredScreen1 = new physbeans.inout.LayeredScreen();
    outputPanel1 = new physbeans.inout.OutputPanel();
    oscilloscope1 = new physbeans.inout.Oscilloscope();
    inputPanel1 = new physbeans.inout.InputPanel();
    timer1 = new physbeans.inout.Timer();
    textSlider1 = new physbeans.inout.TextSlider();
    textSlider2 = new physbeans.inout.TextSlider();
    textSlider4 = new physbeans.inout.TextSlider();
    textSlider5 = new physbeans.inout.TextSlider();
    textSlider3 = new physbeans.inout.TextSlider();

    rippleTank1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        rippleTank1SourceChanged(evt);
      }
    });

    lineWaveSource1.setAmplitude(0.25);
    lineWaveSource1.setPosition1(DVector.valueOf("[-1.0,0.5]"));
    lineWaveSource1.setPosition2(DVector.valueOf("[-0.5,1.0]"));
    lineWaveSource1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        lineWaveSource1SourceChanged(evt);
      }
    });

    lineWaveSource2.setPosition1(DVector.valueOf("[-1.0,-0.5]"));
    lineWaveSource2.setPosition2(DVector.valueOf("[-0.5,-1.0]"));
    lineWaveSource2.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        lineWaveSource2SourceChanged(evt);
      }
    });

    gridView1.setDepth(60);
    gridView1.setInfiniteScale(true);
    gridView1.setMaxVal(0.3);
    gridView1.setMinVal(-0.3);
    gridView1.setScale(0.2);
    gridView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        gridView1SourceChanged(evt);
      }
    });

    simpleFigureView1.setFigureType(7);
    simpleFigureView1.setFilled(true);
    simpleFigureView1.setP2(DVector.valueOf("[0.03,0.03]"));
    simpleFigureView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        simpleFigureView1SourceChanged(evt);
      }
    });

    pointDetector1.setField(rippleTank1);
    pointDetector1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        pointDetector1SourceChanged(evt);
      }
    });
    pointDetector1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        pointDetector1ValueChanged(evt);
      }
    });

    jPanel1.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED)));
    jPanel1.setFont(standardFont);
    jPanel1.setLayout(new java.awt.BorderLayout());

    jPanel2.setFont(standardFont);
    jPanel2.setPreferredSize(new java.awt.Dimension(290, 300));
    jPanel2.setLayout(new java.awt.BorderLayout());

    objectPanel1.setPreferredSize(new java.awt.Dimension(315, 315));
    objectPanel1.add(layeredScreen1, java.awt.BorderLayout.CENTER);

    jPanel2.add(objectPanel1, java.awt.BorderLayout.NORTH);

    outputPanel1.setPreferredSize(new java.awt.Dimension(4, 195));

    oscilloscope1.setNLines(1);
    oscilloscope1.setMaxY(0.8);
    oscilloscope1.setMinY(-0.8);
    java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("physapps.waves.PerpendicularPlaneWaves", currentLocale); // NOI18N
    oscilloscope1.setPositionLabel(bundle.getString("osciPosition")); // NOI18N
    oscilloscope1.setScaleLabel(bundle.getString("osciScale")); // NOI18N
    oscilloscope1.setTimePerTick(0.0101010101);
    outputPanel1.add(oscilloscope1);

    jPanel2.add(outputPanel1, java.awt.BorderLayout.CENTER);

    jPanel1.add(jPanel2, java.awt.BorderLayout.CENTER);

    inputPanel1.setLayout(new javax.swing.BoxLayout(inputPanel1, javax.swing.BoxLayout.Y_AXIS));

    timer1.setDelay(30L);
    timer1.setExplanation(bundle.getString("timerLabel")); // NOI18N
    timer1.setTimeIncrement(0.0101010101);
    timer1.addTimerListener(new physbeans.event.TimerListener() {
      public void nextStep(physbeans.event.NextStepEvent evt) {
        timer1NextStep(evt);
      }
      public void restart(physbeans.event.RestartEvent evt) {
        timer1Restart(evt);
      }
    });
    inputPanel1.add(timer1);

    textSlider1.setDescription("f =");
    textSlider1.setLogarithmic(true);
    textSlider1.setModel(new BoundedRealModel(2.0,4.2,10.0));
    textSlider1.setUnit("Hz");
    textSlider1.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider1PropertyChange(evt);
      }
    });
    inputPanel1.add(textSlider1);

    textSlider2.setDescription("A2 =");
    textSlider2.setModel(new BoundedRealModel(0.0,0.25,0.4));
    textSlider2.setUnit("m");
    textSlider2.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider2PropertyChange(evt);
      }
    });
    inputPanel1.add(textSlider2);

    textSlider4.setDescription("\u03c62 =");
    textSlider4.setModel(new BoundedRealModel(-1.0,0.0,1.0));
    textSlider4.setUnit("* \u03c0");
    textSlider4.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider4PropertyChange(evt);
      }
    });
    inputPanel1.add(textSlider4);

    textSlider5.setDescription("x =");
    textSlider5.setModel(new BoundedRealModel(-0.99,0.0,0.99));
    textSlider5.setUnit("m");
    textSlider5.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider5PropertyChange(evt);
      }
    });
    inputPanel1.add(textSlider5);

    textSlider3.setDescription("y =");
    textSlider3.setModel(new BoundedRealModel(-0.99,0.0,0.99));
    textSlider3.setUnit("m");
    textSlider3.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider3PropertyChange(evt);
      }
    });
    inputPanel1.add(textSlider3);

    jPanel1.add(inputPanel1, java.awt.BorderLayout.EAST);

    getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
  }// </editor-fold>//GEN-END:initComponents

  private void lineWaveSource2SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_lineWaveSource2SourceChanged
    rippleTank1.addSource(lineWaveSource2);
  }//GEN-LAST:event_lineWaveSource2SourceChanged

  private void lineWaveSource1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_lineWaveSource1SourceChanged
    rippleTank1.addSource(lineWaveSource1);
  }//GEN-LAST:event_lineWaveSource1SourceChanged

  private void pointDetector1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_pointDetector1SourceChanged
    simpleFigureView1.setP1(pointDetector1.getPosition());
  }//GEN-LAST:event_pointDetector1SourceChanged
  
  private void simpleFigureView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_simpleFigureView1SourceChanged
    layeredScreen1.addView(simpleFigureView1);
  }//GEN-LAST:event_simpleFigureView1SourceChanged
  
  private void gridView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_gridView1SourceChanged
    layeredScreen1.addView(gridView1);
  }//GEN-LAST:event_gridView1SourceChanged
  
  private void textSlider5PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider5PropertyChange
    pointDetector1.setInitialPositionX(textSlider5.getValue());
  }//GEN-LAST:event_textSlider5PropertyChange
  
  private void pointDetector1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_pointDetector1ValueChanged
    oscilloscope1.setInputVector(pointDetector1.getOutputVector());
    simpleFigureView1.setP1(pointDetector1.getPosition());
  }//GEN-LAST:event_pointDetector1ValueChanged
  
  private void textSlider4PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider4PropertyChange
    lineWaveSource2.setPhase(textSlider4.getValue()*Math.PI);
  }//GEN-LAST:event_textSlider4PropertyChange
  
  private void textSlider3PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider3PropertyChange
    pointDetector1.setInitialPositionY(textSlider3.getValue());
  }//GEN-LAST:event_textSlider3PropertyChange
  
  private void textSlider2PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider2PropertyChange
    double val = textSlider2.getValue();
    lineWaveSource2.setAmplitude(val);
  }//GEN-LAST:event_textSlider2PropertyChange
  
  private void textSlider1PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider1PropertyChange
    double val = textSlider1.getValue();
    lineWaveSource1.setFrequency(val);
    lineWaveSource2.setFrequency(val);
  }//GEN-LAST:event_textSlider1PropertyChange
  
  private void timer1Restart(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart
    rippleTank1.restart();
    pointDetector1.restart();
    oscilloscope1.restart();
  }//GEN-LAST:event_timer1Restart
  
  private void timer1NextStep(physbeans.event.NextStepEvent evt) {//GEN-FIRST:event_timer1NextStep
    rippleTank1.nextStep();
    pointDetector1.setTime(timer1.getTime());
  }//GEN-LAST:event_timer1NextStep
  
  private void rippleTank1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_rippleTank1SourceChanged
    gridView1.setModel(rippleTank1);
  }//GEN-LAST:event_rippleTank1SourceChanged
  
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  protected physbeans.views.GridView gridView1;
  protected physbeans.inout.InputPanel inputPanel1;
  protected javax.swing.JPanel jPanel1;
  protected javax.swing.JPanel jPanel2;
  protected physbeans.inout.LayeredScreen layeredScreen1;
  protected physbeans.phys.LineWaveSource lineWaveSource1;
  protected physbeans.phys.LineWaveSource lineWaveSource2;
  protected physbeans.inout.ObjectPanel objectPanel1;
  protected physbeans.inout.Oscilloscope oscilloscope1;
  protected physbeans.inout.OutputPanel outputPanel1;
  protected physbeans.func.PointDetector pointDetector1;
  protected physbeans.phys.RippleTank rippleTank1;
  protected physbeans.views.SimpleFigureView simpleFigureView1;
  protected physbeans.inout.TextSlider textSlider1;
  protected physbeans.inout.TextSlider textSlider2;
  protected physbeans.inout.TextSlider textSlider3;
  protected physbeans.inout.TextSlider textSlider4;
  protected physbeans.inout.TextSlider textSlider5;
  protected physbeans.inout.Timer timer1;
  // End of variables declaration//GEN-END:variables
  
}
